
/*  A Bison parser, made from ../../rlplot/mfcalc.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUM	257
#define	BOOLVAL	258
#define	STR	259
#define	ARR	260
#define	BLOCK	261
#define	PI	262
#define	E	263
#define	CLVAL	264
#define	PSEP	265
#define	IF	266
#define	ELSE	267
#define	BTRUE	268
#define	BFALSE	269
#define	DATE1	270
#define	TIME1	271
#define	DATETIME1	272
#define	DIM	273
#define	VAR	274
#define	FNCT	275
#define	BFNCT	276
#define	AFNCT	277
#define	SFNCT	278
#define	FUNC1	279
#define	FUNC2	280
#define	FUNC3	281
#define	TXT	282
#define	SRFUNC	283
#define	YYFNC	284
#define	FUNC4	285
#define	CLAUSE	286
#define	SER	287
#define	COLR	288
#define	COLC	289
#define	AND	290
#define	OR	291
#define	EQ	292
#define	NE	293
#define	GT	294
#define	GE	295
#define	LT	296
#define	LE	297
#define	NEG	298
#define	INC	299
#define	DEC	300
#define	PINC	301
#define	PDEC	302
#define	PDIM	303


/*
 mfcalc.y, mfcalc.cpp, Copyright (c) 2004-2006 R.Lackner
 parse string and simple math: based on the bison 'mfcalc' example

    This file is part of RLPlot.

    RLPlot is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    RLPlot is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with RLPlot; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include "rlplot.h"

class symrec {
public:
	int type, row, col, a_count;
	unsigned int h_name, h2_name;
	char *name, *text;
	double (*fnctptr)(...);
	symrec *next;
	double var, *a_data;

	symrec(unsigned int h_n, unsigned int h2_n, int typ, symrec *nxt);
	~symrec();
	double GetValue();
	void GetValue(void *res);
	double SetValue(double v);
        void SetValue(void* dest, void* src);
	void SetName(char *nam);
	void InitSS();

private:
	bool isSSval;

};

// syntactical information
struct syntax_info {
	int last_tok;			//resolve ambiguous ':'
	double clval;			//current value for where - clause
	int cl1, cl2;			//limits of clause formula in buffer
	struct syntax_info *next;
	};
static syntax_info *syntax_level = 0L;


typedef struct{
	double  val;
	int type;
	symrec  *tptr;
	double *a_data;
	char *text;
	int a_count;

}YYSTYPE;

static symrec *putsym (unsigned int h_name, unsigned int h2_name, int sym_type);
static symrec *getsym (unsigned int h_name, unsigned int h2_name, char *sym_name = 0L);
static int push(YYSTYPE *res, YYSTYPE *val);
static void store_res(YYSTYPE *res);
static char *PushString(char *text);
static double *PushArray(double *arr);
static double *ReallocArray(double *arr, int size);
static char *add_strings(char *st1, char *st2);
static char *string_value(YYSTYPE *exp);
static double eval(YYSTYPE *sr, YYSTYPE *dst, char* dum);
static int range_array(YYSTYPE * res, char *range);
static int range_array2(YYSTYPE *res1, YYSTYPE *res2);
static void exec_clause(YYSTYPE *res);
static YYSTYPE *proc_clause(YYSTYPE *res);
static void yyerror(char *s);
static void make_time(YYSTYPE *dst, double h, double m, double s);
static int yylex(void);
static double nop() {return 0.0;};

static char res_txt[1000];
static anyResult line_res = {ET_UNKNOWN, 0.0, res_txt};
static DataObj *curr_data;
static char *last_error = 0L;		//error text
static char *last_err_desc = 0L;	//short error description

static char *buffer = 0L;		//the current command buffer
static int buff_pos = 0;
static bool bRecent = false;		//rearrange functions
static int parse_level = 0;		//count reentrances into parser
#define MAX_PARSE 20			//maximum number of reentances 
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		222
#define	YYFLAG		-32768
#define	YYNTBASE	65

#define YYTRANSLATE(x) ((unsigned)(x) <= 303 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    59,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    61,
    62,    49,    48,    33,    47,     2,    50,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    64,    60,     2,
    32,     2,    38,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    51,     2,    63,    58,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    34,    35,    36,    37,    39,
    40,    41,    42,    43,    44,    45,    46,    52,    53,    54,
    55,    56,    57
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     8,    10,    13,    16,    19,    22,
    25,    28,    30,    34,    38,    42,    47,    54,    61,    68,
    75,    77,    81,    83,    85,    89,    93,    95,    99,   101,
   106,   108,   110,   114,   118,   122,   126,   130,   134,   138,
   142,   144,   146,   148,   150,   152,   154,   156,   158,   162,
   166,   171,   176,   183,   192,   197,   202,   209,   216,   223,
   230,   237,   244,   251,   258,   265,   274,   281,   290,   301,
   308,   312,   317,   323,   331,   335,   339,   343,   347,   350,
   353,   356,   359,   362,   366,   370,   376,   381,   388,   394,
   400,   404,   408,   414,   420,   426
};

static const short yyrhs[] = {    -1,
    65,    66,     0,    59,     0,    60,     0,    33,     0,    71,
    59,     0,    71,    60,     0,    71,    33,     0,    67,    59,
     0,    67,    60,     0,     1,    59,     0,     5,     0,    67,
    48,    71,     0,    71,    48,    67,     0,    67,    48,    67,
     0,    29,    61,    71,    62,     0,    29,    61,    71,    11,
    67,    62,     0,    29,    61,    71,    11,    71,    62,     0,
    29,    61,    71,    33,    67,    62,     0,    29,    61,    71,
    33,    71,    62,     0,    67,     0,    20,    36,    20,     0,
     6,     0,    71,     0,    69,    33,    69,     0,    69,    34,
    71,     0,    68,     0,     3,    35,     3,     0,     4,     0,
    22,    61,    71,    62,     0,    14,     0,    15,     0,    71,
    39,    71,     0,    71,    40,    71,     0,    71,    41,    71,
     0,    71,    42,    71,     0,    71,    43,    71,     0,    71,
    44,    71,     0,    71,    45,    71,     0,    71,    46,    71,
     0,     3,     0,    70,     0,    28,     0,    10,     0,     8,
     0,     9,     0,    20,     0,     7,     0,    20,    32,    71,
     0,    20,    32,    67,     0,    21,    61,    71,    62,     0,
    23,    61,    69,    62,     0,    23,    61,    71,    11,    69,
    62,     0,    23,    61,    71,    11,    71,    11,    71,    62,
     0,    24,    61,    67,    62,     0,    24,    61,    71,    62,
     0,    24,    61,    67,    11,    67,    62,     0,    24,    61,
    71,    11,    67,    62,     0,    24,    61,    71,    11,    71,
    62,     0,    24,    61,    67,    11,    71,    62,     0,    24,
    61,    67,    33,    67,    62,     0,    24,    61,    71,    33,
    67,    62,     0,    24,    61,    67,    33,    71,    62,     0,
    24,    61,    71,    33,    71,    62,     0,    26,    61,    68,
    11,    68,    62,     0,    26,    61,    68,    11,    68,    11,
    68,    62,     0,    27,    61,    69,    11,    69,    62,     0,
    27,    61,    69,    11,    69,    11,    68,    62,     0,    31,
    61,    71,    11,    71,    11,    69,    11,    68,    62,     0,
    25,    61,    69,    11,    68,    62,     0,    30,    61,    62,
     0,    30,    61,    69,    62,     0,    12,    61,    71,    62,
     7,     0,    12,    61,    71,    62,     7,    13,     7,     0,
    71,    48,    71,     0,    71,    47,    71,     0,    71,    49,
    71,     0,    71,    50,    71,     0,    47,    71,     0,    20,
    53,     0,    20,    54,     0,    53,    20,     0,    54,    20,
     0,    71,    58,    71,     0,    61,    69,    62,     0,    19,
    20,    51,    71,    63,     0,    71,    51,    71,    63,     0,
    71,    51,    71,    63,    32,    71,     0,     3,    36,     3,
    36,     3,     0,     3,    64,     3,    64,     3,     0,     3,
    36,     3,     0,     3,    64,     3,     0,    71,    38,    71,
    37,    71,     0,    71,    38,     5,    37,     5,     0,    71,
    38,     5,    37,    71,     0,    71,    38,    71,    37,     5,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   128,   129,   132,   132,   132,   133,   134,   135,   136,   137,
   138,   141,   143,   144,   145,   146,   147,   148,   149,   150,
   153,   155,   159,   160,   161,   162,   163,   164,   168,   169,
   170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
   182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
   192,   193,   194,   196,   199,   200,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,   217,   218,   219,   223,   227,   228,   230,   231,
   232,   233,   234,   235,   236,   237,   239,   241,   243,   244,
   245,   246,   247,   248,   249,   250
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NUM","BOOLVAL",
"STR","ARR","BLOCK","PI","E","CLVAL","PSEP","IF","ELSE","BTRUE","BFALSE","DATE1",
"TIME1","DATETIME1","DIM","VAR","FNCT","BFNCT","AFNCT","SFNCT","FUNC1","FUNC2",
"FUNC3","TXT","SRFUNC","YYFNC","FUNC4","'='","','","CLAUSE","SER","COLR","COLC",
"'?'","AND","OR","EQ","NE","GT","GE","LT","LE","'-'","'+'","'*'","'/'","'['",
"NEG","INC","DEC","PINC","PDEC","PDIM","'^'","'\\n'","';'","'('","')'","']'",
"':'","input","line","str_exp","range","arr","bool","exp", NULL
};
#endif

static const short yyr1[] = {     0,
    65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    68,    68,    69,    69,    69,    69,    69,    69,    70,    70,
    70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71
};

static const short yyr2[] = {     0,
     0,     2,     1,     1,     1,     2,     2,     2,     2,     2,
     2,     1,     3,     3,     3,     4,     6,     6,     6,     6,
     1,     3,     1,     1,     3,     3,     1,     3,     1,     4,
     1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
     4,     4,     6,     8,     4,     4,     6,     6,     6,     6,
     6,     6,     6,     6,     6,     8,     6,     8,    10,     6,
     3,     4,     5,     7,     3,     3,     3,     3,     2,     2,
     2,     2,     2,     3,     3,     5,     4,     6,     5,     5,
     3,     3,     5,     5,     5,     5
};

static const short yydefact[] = {     1,
     0,     0,    41,    29,    12,    48,    45,    46,    44,     0,
    31,    32,     0,    47,     0,     0,     0,     0,     0,     0,
     0,    43,     0,     0,     0,     5,     0,     0,     0,     3,
     4,     0,     2,     0,    42,     0,    11,     0,     0,     0,
     0,     0,    80,    81,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    79,    82,    83,    41,    23,    47,
    21,    27,     0,    24,     0,     9,    10,     8,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     6,     7,    91,    92,     0,     0,    50,
    49,     0,     0,     0,    24,     0,     0,     0,     0,     0,
     0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
    85,    15,    13,     0,     0,    33,    34,    35,    36,    37,
    38,    39,    40,    76,    14,    75,    77,    78,     0,    84,
     0,     0,     0,     0,    51,    30,    52,     0,     0,     0,
    55,     0,     0,    56,     0,     0,     0,     0,     0,    16,
    72,     0,    75,    28,    22,    25,    26,     0,     0,    87,
    89,    90,    73,    86,     0,    24,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    94,    95,    96,    93,     0,     0,    53,     0,
    57,    60,    61,    63,    58,    59,    62,    64,    70,     0,
    65,     0,    67,    17,    18,    19,    20,     0,    88,    74,
     0,     0,     0,     0,    54,    66,    68,     0,     0,    69,
     0,     0
};

static const short yydefgoto[] = {     1,
    33,    61,    62,    63,    35,    64
};

static const short yypact[] = {-32768,
   204,   -44,   -26,-32768,-32768,-32768,-32768,-32768,-32768,   -45,
-32768,-32768,     5,    33,   -42,   -25,     6,    22,    24,    32,
    39,-32768,    41,    49,    54,-32768,   646,    36,    38,-32768,
-32768,   323,-32768,   105,-32768,   799,-32768,    14,    57,   646,
    10,   378,-32768,-32768,   646,   646,   323,   378,   323,   433,
   323,   646,   263,   646,     8,-32768,-32768,   -27,-32768,    63,
    55,-32768,   -20,   994,   378,-32768,-32768,-32768,   488,   646,
   646,   646,   646,   646,   646,   646,   646,   646,   378,   646,
   646,   646,   646,-32768,-32768,    83,    76,   372,   646,    55,
   994,   427,   482,   -12,    85,     0,   670,     1,   111,   994,
    78,   711,-32768,   -10,   736,   646,   146,   130,   323,   646,
-32768,-32768,   129,   118,   973,   197,   197,   125,   125,   125,
   125,   125,   125,   129,-32768,   129,   -31,   -31,   257,     8,
   153,   156,   154,   317,-32768,-32768,-32768,   323,   378,   378,
-32768,   378,   378,-32768,   433,   433,   323,   378,   378,-32768,
-32768,   646,   129,-32768,-32768,   132,  1015,   543,   598,   131,
-32768,-32768,   155,-32768,    -3,   757,   -30,   537,    -8,   822,
    46,   847,    56,   872,   107,    -7,    -5,    58,   897,    98,
   922,   778,-32768,  1015,-32768,  1015,   646,   160,-32768,   646,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   433,
-32768,   433,-32768,-32768,-32768,-32768,-32768,   323,  1015,-32768,
   947,   109,   115,    80,-32768,-32768,-32768,   433,   126,-32768,
   192,-32768
};

static const short yypgoto[] = {-32768,
-32768,    42,   -48,   -46,-32768,    -1
};


#define	YYLAST		1073


static const short yytable[] = {    36,
    94,    99,    98,   200,   101,   202,   104,   107,    38,    38,
   139,   145,   109,   110,    37,    40,    86,    65,    45,    82,
   109,   110,   109,   110,    41,    55,    83,   109,   110,   109,
   110,   191,   140,   109,   110,    46,    39,    39,    88,    65,
    91,   111,    34,    92,    93,    95,    97,    65,   100,   137,
   102,   151,   105,   193,   201,    56,   203,    57,   189,    87,
    89,   141,   156,   113,    42,    83,    47,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   126,   127,   128,
   129,   130,    48,    90,    49,    43,    44,   134,   147,    96,
   218,   165,    50,    65,    42,   138,   175,   176,   108,    51,
   177,    52,    65,    65,   153,    65,   112,   195,   157,    53,
   109,   110,   109,   110,    54,    43,    44,   197,   131,   204,
   125,   146,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,   166,   168,   170,   132,
   172,   174,    83,   100,   100,    65,   179,   181,   154,   155,
   182,   212,    65,   213,   158,   161,   184,   186,   162,   206,
   163,   214,   187,    66,    67,   110,   210,   188,   199,   219,
   216,    78,   106,    80,    81,    82,   217,    80,    81,    82,
   167,   169,    83,   171,   173,   209,    83,   220,   211,   178,
   180,   222,     0,     0,     0,     0,     0,     0,   100,     0,
   100,     0,     0,   221,     2,     0,     3,     4,     5,     0,
     6,     7,     8,     9,     0,    10,   100,    11,    12,     0,
     0,     0,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,     0,    26,    72,    73,    74,
    75,    76,    77,    78,   106,    80,    81,    82,     0,     0,
    27,     0,     0,     0,    83,     0,    28,    29,     0,     0,
     0,     0,    30,    31,    32,    58,     4,     5,    59,     6,
     7,     8,     9,     0,    10,     0,    11,    12,     0,     0,
     0,    13,    60,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,   106,    80,    81,    82,     0,    27,
     0,     0,     0,     0,    83,    28,    29,     0,     0,   160,
     0,     0,     0,    32,   103,    58,     4,     5,    59,     6,
     7,     8,     9,     0,    10,     0,    11,    12,     0,     0,
     0,    13,    60,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,   106,    80,    81,    82,     0,    27,
     0,     0,     0,     0,    83,    28,    29,     0,     0,   164,
     3,     4,     5,    32,     6,     7,     8,     9,     0,    10,
     0,    11,    12,     0,     0,     0,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,   106,
    80,    81,    82,     0,    27,     0,     0,     0,     0,    83,
    28,    29,     0,   133,     0,     3,     4,     5,    32,     6,
     7,     8,     9,     0,    10,     0,    11,    12,     0,     0,
     0,    13,    60,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,   106,    80,    81,    82,     0,    27,
     0,     0,     0,     0,    83,    28,    29,     0,   135,     0,
     3,     4,   114,    32,     6,     7,     8,     9,     0,    10,
     0,    11,    12,     0,     0,     0,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,     0,    24,    25,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,   106,
    80,    81,    82,     0,    27,     0,     0,     0,     0,    83,
    28,    29,     0,   136,     0,     3,     4,   183,    32,     6,
     7,     8,     9,     0,    10,     0,    11,    12,     0,     0,
     0,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,     0,    24,    25,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,     0,    27,
     0,     0,     0,     0,    83,    28,    29,     0,   192,     0,
     3,     4,   185,    32,     6,     7,     8,     9,     0,    10,
     0,    11,    12,     0,     0,     0,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,     0,    24,    25,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    27,     0,     0,     0,     3,     4,
    28,    29,     6,     7,     8,     9,     0,    10,    32,    11,
    12,     0,     0,     0,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,     0,    24,    25,     0,     0,     0,
   142,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    27,     0,     0,     0,     0,     0,    28,    29,
     0,     0,   143,     0,     0,     0,    32,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,   148,     0,     0,     0,     0,     0,    83,     0,     0,
     0,   144,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   149,     0,     0,   152,     0,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,   106,    80,
    81,    82,     0,     0,     0,     0,     0,   190,    83,     0,
     0,     0,   150,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,   106,    80,    81,    82,     0,   208,     0,
     0,     0,     0,    83,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,     0,     0,
     0,     0,     0,     0,    83,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,   106,    80,    81,    82,     0,
     0,    68,     0,     0,     0,    83,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
     0,     0,     0,     0,     0,     0,    83,    84,    85,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,     0,     0,     0,     0,     0,     0,    83,
     0,     0,     0,   194,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,     0,     0,
     0,     0,     0,     0,    83,     0,     0,     0,   196,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,     0,     0,     0,     0,     0,     0,    83,
     0,     0,     0,   198,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,     0,     0,
     0,     0,     0,     0,    83,     0,     0,     0,   205,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,     0,     0,     0,     0,     0,     0,    83,
     0,     0,     0,   207,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,   106,    80,    81,    82,     0,     0,
     0,     0,     0,     0,    83,     0,     0,     0,   215,   159,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
   106,    80,    81,    82,     0,     0,     0,     0,     0,     0,
    83,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
     0,    83,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,   106,    80,    81,    82,     0,     0,     0,     0,
     0,     0,    83
};

static const short yycheck[] = {     1,
    47,    50,    49,    11,    51,    11,    53,    35,    36,    36,
    11,    11,    33,    34,    59,    61,     3,    48,    61,    51,
    33,    34,    33,    34,    20,    27,    58,    33,    34,    33,
    34,    62,    33,    33,    34,    61,    64,    64,    40,    48,
    42,    62,     1,    45,    46,    47,    48,    48,    50,    62,
    52,    62,    54,    62,    62,    20,    62,    20,    62,     3,
    51,    62,   109,    65,    32,    58,    61,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    61,    42,    61,    53,    54,    89,    11,    48,
    11,   138,    61,    48,    32,    11,   145,   146,    36,    61,
   147,    61,    48,    48,   106,    48,    65,    62,   110,    61,
    33,    34,    33,    34,    61,    53,    54,    62,    36,    62,
    79,    11,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,   138,   139,   140,    64,
   142,   143,    58,   145,   146,    48,   148,   149,     3,    20,
   152,   200,    48,   202,    37,     3,   158,   159,     3,    62,
     7,   208,    32,    59,    60,    34,     7,    13,    62,   218,
    62,    47,    48,    49,    50,    51,    62,    49,    50,    51,
   139,   140,    58,   142,   143,   187,    58,    62,   190,   148,
   149,     0,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,
   202,    -1,    -1,     0,     1,    -1,     3,     4,     5,    -1,
     7,     8,     9,    10,    -1,    12,   218,    14,    15,    -1,
    -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    -1,    33,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
    47,    -1,    -1,    -1,    58,    -1,    53,    54,    -1,    -1,
    -1,    -1,    59,    60,    61,     3,     4,     5,     6,     7,
     8,     9,    10,    -1,    12,    -1,    14,    15,    -1,    -1,
    -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    47,
    -1,    -1,    -1,    -1,    58,    53,    54,    -1,    -1,    63,
    -1,    -1,    -1,    61,    62,     3,     4,     5,     6,     7,
     8,     9,    10,    -1,    12,    -1,    14,    15,    -1,    -1,
    -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    47,
    -1,    -1,    -1,    -1,    58,    53,    54,    -1,    -1,    63,
     3,     4,     5,    61,     7,     8,     9,    10,    -1,    12,
    -1,    14,    15,    -1,    -1,    -1,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    -1,    47,    -1,    -1,    -1,    -1,    58,
    53,    54,    -1,    62,    -1,     3,     4,     5,    61,     7,
     8,     9,    10,    -1,    12,    -1,    14,    15,    -1,    -1,
    -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    47,
    -1,    -1,    -1,    -1,    58,    53,    54,    -1,    62,    -1,
     3,     4,     5,    61,     7,     8,     9,    10,    -1,    12,
    -1,    14,    15,    -1,    -1,    -1,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    -1,    30,    31,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    -1,    47,    -1,    -1,    -1,    -1,    58,
    53,    54,    -1,    62,    -1,     3,     4,     5,    61,     7,
     8,     9,    10,    -1,    12,    -1,    14,    15,    -1,    -1,
    -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    -1,    30,    31,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    47,
    -1,    -1,    -1,    -1,    58,    53,    54,    -1,    62,    -1,
     3,     4,     5,    61,     7,     8,     9,    10,    -1,    12,
    -1,    14,    15,    -1,    -1,    -1,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    -1,    30,    31,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,     3,     4,
    53,    54,     7,     8,     9,    10,    -1,    12,    61,    14,
    15,    -1,    -1,    -1,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    -1,    30,    31,    -1,    -1,    -1,
    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    54,
    -1,    -1,    33,    -1,    -1,    -1,    61,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    11,    -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,
    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    33,    -1,    -1,    11,    -1,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    -1,    -1,    -1,    -1,    -1,    11,    58,    -1,
    -1,    -1,    62,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    -1,    11,    -1,
    -1,    -1,    -1,    58,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
    -1,    -1,    -1,    -1,    58,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
    -1,    33,    -1,    -1,    -1,    58,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    -1,    -1,    -1,    -1,    -1,    -1,    58,    59,    60,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,
    -1,    -1,    -1,    62,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,
    -1,    -1,    -1,    62,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,
    -1,    -1,    -1,    62,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,
    58,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    -1,    -1,    -1,    -1,    -1,
    -1,    58,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    -1,    -1,    -1,    -1,
    -1,    -1,    58
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 6:
{store_res(&yyvsp[-1]); return 0;;
    break;}
case 7:
{store_res(&yyvsp[-1]); return 0;;
    break;}
case 8:
{store_res(&yyvsp[-1]); return 0;;
    break;}
case 9:
{store_res(&yyvsp[-1]); return 0;;
    break;}
case 10:
{store_res(&yyvsp[-1]); return 0;;
    break;}
case 11:
{yyerrok;;
    break;}
case 12:
{;;
    break;}
case 13:
{yyval.text=add_strings(yyvsp[-2].text, string_value(&yyvsp[0])); yyval.type = STR;;
    break;}
case 14:
{yyval.text=add_strings(string_value(&yyvsp[-2]), yyvsp[0].text); yyval.type = STR;;
    break;}
case 15:
{yyval.text=add_strings(yyvsp[-2].text, yyvsp[0].text); yyval.type = STR;;
    break;}
case 16:
{((yyvsp[-3].tptr->fnctptr)(&yyval, &yyvsp[-1], 0L)); yyval.type = STR;;
    break;}
case 17:
{((yyvsp[-5].tptr->fnctptr)(&yyval, &yyvsp[-3], yyvsp[-1].text)); yyval.type = STR;;
    break;}
case 18:
{((yyvsp[-5].tptr->fnctptr)(&yyval, &yyvsp[-3], yyvsp[-1].text)); yyval.type = STR;;
    break;}
case 19:
{((yyvsp[-5].tptr->fnctptr)(&yyval, &yyvsp[-3], yyvsp[-1].text)); yyval.type = STR;;
    break;}
case 20:
{((yyvsp[-5].tptr->fnctptr)(&yyval, &yyvsp[-3], yyvsp[-1].text)); yyval.type = STR;;
    break;}
case 21:
{;;
    break;}
case 22:
{if(yyval.text = PushString("                                            ")) 
					sprintf(yyval.text, "%s:%s", yyvsp[-2].tptr->name, yyvsp[0].tptr->name); yyval.type = STR;;
    break;}
case 24:
{if(!yyval.a_data) {yyval.a_data = PushArray((double*)malloc(sizeof(double))); yyval.a_count = 1; yyval.a_data[0] = yyval.val;};
    break;}
case 25:
{push(&yyval, &yyvsp[0]);yyval.type = ARR;;
    break;}
case 26:
{exec_clause(&yyval);yyval.type = ARR;;
    break;}
case 27:
{range_array(&yyval, yyvsp[0].text);yyval.type = ARR;;
    break;}
case 28:
{if(yyvsp[-2].val < yyvsp[0].val && (yyval.a_data = PushArray((double*)malloc((int)(yyvsp[0].val-yyvsp[-2].val+2)*sizeof(double)))))
					for(yyval.a_count=0; yyvsp[-2].val<=yyvsp[0].val; yyval.a_data[yyval.a_count++] = yyvsp[-2].val, yyvsp[-2].val += 1.0 ); yyval.type = ARR;;
    break;}
case 30:
{yyval.val = ((yyvsp[-3].tptr->fnctptr)(yyvsp[-1].val)); yyval.type = BOOLVAL;;
    break;}
case 31:
{yyval.val = 1.0; yyval.type = BOOLVAL;;
    break;}
case 32:
{yyval.val = 0.0; yyval.type = BOOLVAL;;
    break;}
case 33:
{yyval.val = ((yyvsp[-2].val != 0) && (yyvsp[0].val != 0))? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 34:
{yyval.val = ((yyvsp[-2].val != 0) || (yyvsp[0].val != 0))? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 35:
{yyval.val = (yyvsp[-2].val == yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 36:
{yyval.val = (yyvsp[-2].val != yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 37:
{yyval.val = (yyvsp[-2].val > yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 38:
{yyval.val = (yyvsp[-2].val >= yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 39:
{yyval.val = (yyvsp[-2].val < yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 40:
{yyval.val = (yyvsp[-2].val <= yyvsp[0].val) ? 1 : 0; yyval.type = BOOLVAL;;
    break;}
case 41:
{yyval.val = yyvsp[0].val; yyval.type = NUM;;
    break;}
case 42:
{yyval.val = yyvsp[0].val; yyval.type = BOOLVAL;;
    break;}
case 43:
{yyval.val = 0.0;;
    break;}
case 44:
{yyval.val = syntax_level ? syntax_level->clval : 0.0;  yyval.type = NUM;;
    break;}
case 45:
{yyval.val = _PI; yyval.type = NUM;;
    break;}
case 46:
{yyval.val = 2.71828182845905; yyval.type = NUM;;
    break;}
case 47:
{yyvsp[0].tptr->GetValue(&yyval);;
    break;}
case 48:
{eval(&yyvsp[0], &yyval, 0L);;
    break;}
case 49:
{yyvsp[-2].tptr->SetValue(&yyval, &yyvsp[0]);;
    break;}
case 50:
{yyvsp[-2].tptr->SetValue(&yyval, &yyvsp[0]);;
    break;}
case 51:
{yyval.val = ((yyvsp[-3].tptr->fnctptr)(yyvsp[-1].val)); yyval.type = NUM;;
    break;}
case 52:
{yyval.val = ((yyvsp[-3].tptr->fnctptr)(proc_clause(&yyvsp[-1]))); yyval.type = NUM;;
    break;}
case 53:
{ if(!yyval.a_data){yyval.a_data=PushArray((double*)malloc(sizeof(double)));yyval.a_data[0]=yyvsp[-3].val;yyval.a_count=1;}
		push(&yyval, &yyvsp[-1]);yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyval)); yyval.type = NUM;;
    break;}
case 54:
{ yyval.a_data = PushArray((double*)malloc(3*sizeof(double)));
		yyval.a_count = 3; yyval.a_data[0] = yyvsp[-5].val; yyval.a_data[1] = yyvsp[-3].val; yyval.a_data[2] = yyvsp[-1].val;	
		yyval.val = ((yyvsp[-7].tptr->fnctptr)(&yyval)); yyval.type = NUM;;
    break;}
case 55:
{yyval.val = ((yyvsp[-3].tptr->fnctptr)(&yyvsp[-1], &yyval, 0L)); yyval.type = NUM;;
    break;}
case 56:
{yyvsp[-1].text = string_value(&yyvsp[-1]); yyval.val = ((yyvsp[-3].tptr->fnctptr)(&yyvsp[-1], &yyval, 0L)); yyval.type = NUM;;
    break;}
case 57:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 58:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 59:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 60:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 61:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 62:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 63:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 64:
{yyval.val = ((yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyval, yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 65:
{range_array2(&yyvsp[-3], &yyvsp[-1]);yyval.val = ((*yyvsp[-5].tptr->fnctptr)(&yyvsp[-3], &yyvsp[-1], 0L)); yyval.type = NUM;;
    break;}
case 66:
{range_array2(&yyvsp[-5], &yyvsp[-3]); yyval.val = ((*yyvsp[-7].tptr->fnctptr)(&yyvsp[-5], &yyvsp[-3], yyvsp[-1].text)); yyval.type = NUM;;
    break;}
case 67:
{yyval.val=((*yyvsp[-5].tptr->fnctptr)(proc_clause(&yyvsp[-3]), proc_clause(&yyvsp[-1]), 0L));;
    break;}
case 68:
{yyval.val=((*yyvsp[-7].tptr->fnctptr)(proc_clause(&yyvsp[-5]), proc_clause(&yyvsp[-3]), yyvsp[-1].text));;
    break;}
case 69:
{proc_clause(&yyvsp[-3]); yyval.val=(*yyvsp[-9].tptr->fnctptr)(yyvsp[-7].val, yyvsp[-5].val, &yyvsp[-3], &yyvsp[-1]); yyval.type = NUM;;
    break;}
case 70:
{yyval.val = ((*yyvsp[-5].tptr->fnctptr)(proc_clause(&yyvsp[-3]), yyvsp[-1].text));  yyval.type = NUM;;
    break;}
case 71:
{(*yyvsp[-2].tptr->fnctptr)(&yyval, 0L);;
    break;}
case 72:
{(*yyvsp[-3].tptr->fnctptr)(&yyval, &yyvsp[-1]);;
    break;}
case 73:
{yyval.val = yyvsp[-2].val != 0 ? eval(&yyvsp[0], &yyval, 0L) : 0.0;;
    break;}
case 74:
{yyval.val = yyvsp[-4].val != 0.0 ? eval(&yyvsp[-2], &yyval, 0L) : eval(&yyvsp[0], &yyval, 0L);;
    break;}
case 75:
{yyval.val = yyvsp[-2].val + yyvsp[0].val; yyval.type = NUM;
				if(yyvsp[0].type == DATE1 || yyvsp[-2].type == DATE1) yyval.type = DATE1;
				else if(yyvsp[0].type == TIME1 || yyvsp[-2].type == TIME1) yyval.type = TIME1;
				else if(yyvsp[0].type == DATETIME1 || yyvsp[-2].type == DATETIME1) yyval.type = DATETIME1;;
    break;}
case 76:
{yyval.val = yyvsp[-2].val - yyvsp[0].val; yyval.type = NUM;
				if(yyvsp[0].type == DATE1 || yyvsp[-2].type == DATE1) yyval.type = DATE1;
				else if(yyvsp[0].type == TIME1 || yyvsp[-2].type == TIME1) yyval.type = TIME1;
				else if(yyvsp[0].type == DATETIME1 || yyvsp[-2].type == DATETIME1) yyval.type = DATETIME1;;
    break;}
case 77:
{yyval.val = yyvsp[-2].val * yyvsp[0].val; yyval.type = NUM;;
    break;}
case 78:
{yyval.type = NUM; if(yyvsp[0].val != 0.0) yyval.val = yyvsp[-2].val / yyvsp[0].val;
					else yyval.val = (getsym(HashValue((unsigned char*)"zdiv"), Hash2((unsigned char*)"zdiv")))->GetValue(); ;
    break;}
case 79:
{yyval.val = -yyvsp[0].val;;
    break;}
case 80:
{yyval.val=yyvsp[-1].tptr->GetValue(); yyvsp[-1].tptr->SetValue(yyval.val+1.0); yyval.val -= 1.0; yyval.type = NUM;;
    break;}
case 81:
{yyval.val=yyvsp[-1].tptr->GetValue(); yyvsp[-1].tptr->SetValue(yyval.val-1.0); yyval.val += 1.0; yyval.type = NUM;;
    break;}
case 82:
{yyval.val=yyvsp[0].tptr->GetValue(); yyvsp[0].tptr->SetValue(yyval.val+1.0); yyval.type = NUM;;
    break;}
case 83:
{yyval.val=yyvsp[0].tptr->GetValue(); yyvsp[0].tptr->SetValue(yyval.val-1.0); yyval.type = NUM;;
    break;}
case 84:
{yyval.val = pow(yyvsp[-2].val, yyvsp[0].val);;
    break;}
case 85:
{memcpy(&yyval, &yyvsp[-1], sizeof(YYSTYPE)); yyvsp[-1].a_data = 0L; yyvsp[-1].a_count = 0;;
    break;}
case 86:
{yyval.a_data = PushArray((double*)calloc((int)yyvsp[-1].val, sizeof(double))); yyval.a_count=(int)(yyvsp[-1].val); 
					yyval.type = ARR; yyvsp[-3].tptr->SetValue(&yyval,&yyval);;
    break;}
case 87:
{if(yyvsp[-3].a_data && yyvsp[-1].val >= 0.0 && yyvsp[-1].val < yyvsp[-3].a_count) yyval.val = yyvsp[-3].a_data[(int)yyvsp[-1].val];
				else {yyval.val = 0.0; last_err_desc = "#INDEX";} yyval.type = NUM;;
    break;}
case 88:
{if(yyvsp[-5].a_data && yyvsp[-3].val >= 0.0 && yyvsp[-3].val < yyvsp[-5].a_count) yyval.val = yyvsp[-5].a_data[(int)yyvsp[-3].val] = yyvsp[0].val;
				else {yyval.val = 0.0; last_err_desc = "#INDEX";} yyval.type = NUM;;
    break;}
case 89:
{make_time(&yyval, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val+1.0e-10);;
    break;}
case 90:
{make_time(&yyval, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val+1.0e-10);;
    break;}
case 91:
{make_time(&yyval, yyvsp[-2].val, yyvsp[0].val, 1.0e-10);;
    break;}
case 92:
{make_time(&yyval, yyvsp[-2].val, yyvsp[0].val, 1.0e-10);;
    break;}
case 93:
{memcpy(&yyval, yyvsp[-4].val != 0.0 ? &yyvsp[-2] : &yyvsp[0], sizeof(YYSTYPE));
    break;}
case 94:
{memcpy(&yyval, yyvsp[-4].val != 0.0 ? &yyvsp[-2] : &yyvsp[0], sizeof(YYSTYPE));
    break;}
case 95:
{memcpy(&yyval, yyvsp[-4].val != 0.0 ? &yyvsp[-2] : &yyvsp[0], sizeof(YYSTYPE));
    break;}
case 96:
{memcpy(&yyval, yyvsp[-4].val != 0.0 ? &yyvsp[-2] : &yyvsp[0], sizeof(YYSTYPE));
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}


// The symrec class
symrec::symrec(unsigned int h_n, unsigned int h2_n, int typ, symrec *nxt) 
{
	h_name = h_n;	h2_name = h2_n;		type = typ;
	next = nxt;	row = col = -1;		name = text = 0L;
	var = 0.0;	isSSval = false;
	a_data = 0L;	a_count = 0;
	fnctptr = (double (*)(...))nop;
}

symrec::~symrec()
{
	if(name) free(name);	name = 0L;
	if(text) free(text);	text = 0L;
}

double
symrec::GetValue()
{
	anyResult ares;

	if(isSSval) {
		if(row < 0 && col < 0) InitSS();
		//GetResult( , , ,true) inhibits reentrance into parser !
		if(curr_data->GetResult(&ares, row, col, parse_level > MAX_PARSE)){
			return var = ares.value;
			}
		isSSval = false;
		row = col = -1;
		}
	return var;
}

void
symrec::GetValue(void *re)
{
	anyResult ares;
	YYSTYPE *res = (YYSTYPE*)re;

	if(isSSval) {
		if(row < 0 && col < 0) InitSS();
		res->a_data = 0L;	res->a_count = 0;
		//GetResult( , , ,true) inhibits reentrance into parser !
		if(curr_data->GetResult(&ares, row, col, parse_level > MAX_PARSE)){
			if(text) free(text);		text = 0L;
			switch(ares.type) {
			case ET_VALUE:
				res->type = NUM;	res->val = ares.value;
				res->text = 0L;		break;
			case ET_BOOL:
				res->type = BOOLVAL;	res->val = ares.value;
				res->text = 0L;		break;
			case ET_DATE:
				res->type = DATE1;	res->val = ares.value;
				res->text = 0L;		break;
			case ET_TIME:
				res->type = TIME1;	res->val = ares.value;
				res->text = 0L;		break;
			case ET_DATETIME:
				res->type = DATETIME1;	res->val = ares.value;
				res->text = 0L;		break;
			case ET_TEXT:
				res->type = STR;	res->val = 0.0;
				if(ares.text) res->text = PushString(text = strdup(ares.text));
				else res->text = 0L;	break;
			default:
				res->type = NUM;	res->val = var;
				res->text = 0L;		break;
				}
			var = res->val;
			return;
			}
		isSSval = false;
		row = col = -1;
		}
	if(a_data && a_count) {
		res->a_data = a_data;	res->a_count = a_count;
		res->val = 0.0;		res->type = ARR;
		}
	else if(text && text[0]) {
		res->text = PushString(text);
		res->val = var;		res->type = STR;
		}
	else {
		res->type = NUM;	res->val = var;
		res->text = 0L;
		}
}

double 
symrec::SetValue(double v)
{
	if(isSSval) {
		if(row < 0 && col < 0) InitSS();
		if(curr_data->SetValue(row, col, v)){
			if(curr_data) curr_data->Command(CMD_UPDATE, 0L, 0L);
			return var = v;
			}
		isSSval = false;
		row = col = -1;
		}
	a_data = 0L;	a_count = 0;
	return var = v;
}

void 
symrec::SetValue(void* d, void* s)
{
	YYSTYPE *dest = (YYSTYPE*)d;
	YYSTYPE *src = (YYSTYPE*)s;

	if(isSSval && curr_data) {
		if(row < 0 && col < 0) InitSS();
		if(last_err_desc) curr_data->SetText(row, col, last_err_desc);
		else if(src->type == STR) curr_data->SetText(row, col, src->text);
		else if(src->type == ARR || (src->a_data)) curr_data->SetText(row, col, "#ARRAY");
		else if(src->type == VAR && src->tptr->type == TXT) curr_data->SetText(row, col, src->tptr->text);
		else curr_data->SetValue(row, col, src->val);
		curr_data->Command(CMD_UPDATE, 0L, 0L);
		}
	var = src->val;
	if(text) free(text);		text = 0L;
	if(src->text && src->text[0]) 	text = strdup(src->text);
	a_data = src->a_data;		a_count = src->a_count;
	GetValue(d);
	return;
}

void
symrec::SetName(char *nam)
{
	if(name || !nam || !nam[0]) return;
	name = strdup(nam);
	if((name && curr_data) && (isalpha(name[0]) || name[0] == '$') && isdigit(name[strlen(name)-1])) isSSval=true;
}

void
symrec::InitSS()
{
	AccRange *ar;

	if(row<0 && col<0 &&(ar = new AccRange(name))) {
		ar->GetFirst(&col, &row);
		delete(ar);
		}
}

static void yyerror(char *s)
{  
	//called by yyparse on error
	if(curr_data) curr_data->Command(CMD_ERROR, last_error = s, 0L);
	else printf("%s\n", s);
}

static void yyargserr(char *s)
{
	//call from function on argument type/number mismatch
	yyerror(s);
	last_err_desc = "#ARGS";
}

static void make_time(YYSTYPE *dst, double h, double m, double s)
{
	if(!dst || h < 0.0 || 24.0 < h || m < 0.0 || 60.0 < m || s < 0.0 || 60.0 < s) {
		yyerror("parse error");			return;
		}
	dst->val = s/60.0 + m;		dst->val = dst->val/60.0 + h;
	dst->val /= 24.0;		dst->type = TIME1;
}

static void store_res(YYSTYPE *res)
{
	if(last_err_desc) {
		line_res.type = ET_TEXT;
		line_res.value = 0.0;
		strcpy(res_txt, last_err_desc);
		}
	else if(res->type == NUM){
		line_res.type = ET_VALUE;
		line_res.value = res->val;
		}
	else if(res->type == BOOLVAL){
		line_res.type = ET_BOOL;
		line_res.value = res->val;
		}
	else if(res->type == DATE1){
		line_res.type = ET_DATE;
		line_res.value = res->val;
		}
	else if(res->type == TIME1){
		line_res.type = ET_TIME;
		line_res.value = res->val;
		}
	else if(res->type == DATETIME1){
		line_res.type = ET_DATETIME;
		line_res.value = res->val;
		}
 	else if(res->type == STR) {
		line_res.type = ET_TEXT;
		line_res.value = 0.0;
		if(res->text) strcpy(res_txt, res->text);
		}
	else if((res->type == ARR || (res->a_data)) && res->a_count == 1) {
		line_res.type = ET_VALUE;
		line_res.value = res->a_data[0];
		}
	else if(res->type == ARR && !(res->a_data) && !(res->a_count)) {
		line_res.type = ET_VALUE;
		line_res.value = res->val;
		}
	else if(res->type == ARR || (res->a_data)) {
		line_res.type = ET_TEXT;
		line_res.value = 0.0;
		strcpy(res_txt, "#ARRAY");
		}
	else if(res->tptr && res->tptr->type == TXT) {
		line_res.type = ET_TEXT;
		line_res.value = 0.0;
		if(res->tptr->text) strcpy(res_txt, res->tptr->text);
		}
	else {
		line_res.type = ET_VALUE;
		line_res.value = res->val;
		}
}

static char *add_strings(char *st1, char *st2)
{
	char *newstr, *ret;

	if(st1 && st2) {
		if(newstr = (char*)malloc(strlen(st1) +strlen(st2) +4)) {
			sprintf(newstr, "%s%s", st1, st2);
			ret = PushString(newstr);
			free(newstr);
			return ret;
			}
		else return 0L;
		}
	if(st1) return st1;
	if(st2) return st2;
	return 0L;
}

static char *string_value(YYSTYPE *exp)
{
	char *st1, tmp[50];

	if(exp->type == STR){
		st1 = exp->text;
		}
	else if(exp->tptr && exp->tptr->type == TXT) {
		st1 = exp->tptr->text;
		}
	else {
		sprintf(tmp,"%g", exp->val);
		st1 = tmp;
		}
	return PushString(st1);
}

// store syntactical information
static void push_syntax()
{
	syntax_info *next;

	if(!(next = (syntax_info*)calloc(1, sizeof(syntax_info)))) return;
	if(syntax_level)memcpy(next, syntax_level, sizeof(syntax_info));
	next->next=syntax_level;
	syntax_level = next;
}

static void pop_syntax()
{
	syntax_info *si;

	if(si = syntax_level) {
		syntax_level = si->next;
		free(si);
		}
}

static double eval(YYSTYPE *sr, YYSTYPE *dst, char *dum) 
{
	anyResult *ar;

	if(dum) yyerror("parse error");
	if(!sr || !sr->text) return 0.0;
	parse_level++;
	ar = do_formula(0L, sr->text);
	yylval.a_data = 0L;	yylval.a_count = 0;
	switch(ar->type) {
	case ET_VALUE:
		dst->type = NUM;
		dst->val = ar->value;
		dst->text = 0L;
		break;
	case ET_TEXT:
		dst->type = STR;
		dst->val = 0.0;
		dst->text = PushString(ar->text);
		break;
	default:
		dst->type = NUM;
		dst->val = 0.0;
		dst->text = 0L;
		break;
		}
	parse_level--;
	return dst->val;
}

// more functions
static double sign(double v)
{
	if(v > 0.0) return 1.0;
	if(v < 0.0) return -1.0;
	return 0.0;
}

static long idum=0;
static double rand1(YYSTYPE *dst, YYSTYPE *src)
{
	if(!dst) return 0.0;
	dst->type = NUM;
	return(dst->val = ran2(&idum));
}

static double srand(double v)
{
	idum = (long)v;
	return v;
}

static double factorial(double v)
{
	return factrl((int)v);
}

static double _strlen(YYSTYPE *sr, YYSTYPE *dst, char *dum)
{
	if(dum) yyerror("parse error");
	if(!sr || !sr->text) return 0.0;
	return (double)strlen(sr->text);
}

#undef min
static double min(YYSTYPE *sr) 
{
	int i;

	if(!sr || !sr->a_count) return 0.0;
	if(sr->a_data && sr->a_data){
		for(i = 1, sr->val = sr->a_data[0]; i < sr->a_count; i++) 
			if(sr->a_data[i] < sr->val) sr->val = sr->a_data[i];
		}
	return sr->val;
}

#undef max
static double max(YYSTYPE *sr) 
{
	int i;

	if(!sr || !sr->a_count) return 0.0;
	if(sr->a_data){
		for(i = 1, sr->val = sr->a_data[0]; i < sr->a_count; i++) 
			if(sr->a_data[i] > sr->val) sr->val = sr->a_data[i];
		}
	return sr->val;
}

static double count(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	if(sr->a_data) sr->val = (double)sr->a_count;
	else sr->val = 0.0;
	return sr->val;
}

static double sum(YYSTYPE *sr) 
{
	int i;

	if(!sr) return 0.0;
	if(sr->a_data){
		for(i = 0, sr->val = 0.0; i < sr->a_count; i++) sr->val += sr->a_data[i];
		}
	else sr->val = 0.0;
	return sr->val;
}

static double mean(YYSTYPE *sr) 
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		sr->val = d_amean(sr->a_count, sr->a_data );
		}
	return sr->val;
}

static double kurt(YYSTYPE *sr) 
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count > 3){
		sr->val = d_kurt(sr->a_count, sr->a_data );
		}
	return sr->val;
}

static double skew(YYSTYPE *sr) 
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count > 2){
		sr->val = d_skew(sr->a_count, sr->a_data );
		}
	return sr->val;
}

static double gmean(YYSTYPE *sr) 
{
	int i;

	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		for(i = 0; i < sr->a_count; i++) if(sr->a_data[i] <= 0.0) {
			last_err_desc = "#VALUE";
			return sr->val = 0.0;
			}
		sr->val = d_gmean(sr->a_count, sr->a_data );
		}
	return sr->val;
}

static double hmean(YYSTYPE *sr) 
{
	int i;

	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		for(i = 0; i < sr->a_count; i++) if(sr->a_data[i] <= 0.0) {
			last_err_desc = "#VALUE";
			return sr->val = 0.0;
			}
		sr->val = d_hmean(sr->a_count, sr->a_data );
		}
	return sr->val;
}

static double quartile1(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		d_quartile(sr->a_count, sr->a_data, &sr->val, 0L, 0L);
		}
	return sr->val;
}

static double quartile2(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		d_quartile(sr->a_count, sr->a_data, 0L, &sr->val, 0L);
		}
	return sr->val;
}

static double quartile3(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	if(sr->a_data && sr->a_count){
		d_quartile(sr->a_count, sr->a_data, 0L, 0L, &sr->val);
		}
	return sr->val;
}

static double variance(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count){
		sr->val = d_variance(sr->a_count, sr->a_data);
		}
	return sr->val;
}

static double stdev(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count){
		sr->val = sqrt(d_variance(sr->a_count, sr->a_data));
		}
	return sr->val;
}

static double sterr(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count){
		sr->val = sqrt(d_variance(sr->a_count, sr->a_data))/sqrt(sr->a_count);
		}
	return sr->val;
}

static double beta(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2){
		sr->val = betaf(sr->a_data[0], sr->a_data[1]);
		}
	else yyargserr("Wrong number of arguments\nin call to  beta(u, v).");
	return sr->val;
}

static double _gammp(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2){
		sr->val = gammp(sr->a_data[0], sr->a_data[1]);
		}
	else yyargserr("Wrong number of arguments\nin call to  gammp(a, x).");
	return sr->val;
}

static double _gammq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2){
		sr->val = gammq(sr->a_data[0], sr->a_data[1]);
		}
	else yyargserr("Wrong number of arguments\nin call to  gammq(a, x).");
	return sr->val;
}

static double _betai(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 3){
		if(sr->a_data[2] < 0.0 || sr->a_data[2] > 1.0) {
			last_err_desc = "#VALUE";
			return sr->val = 0.0;
			}
		sr->val = betai(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  betai(a, b, x).");
	return sr->val;
}

static double _bincof(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2){
		sr->val = bincof(sr->a_data[0], sr->a_data[1]);
		}
	else yyargserr("Wrong number of arguments\nin call to  bincof(n, k).");
	return sr->val;
}

static double binomdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 3){
		sr->val = binomdistf(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  binomdist(s, n, p).");
	return sr->val;
}

static double binomfreq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 3){
		sr->val = bincof(sr->a_data[1], sr->a_data[0]);
		sr->val *= pow(sr->a_data[2], sr->a_data[0]);
		sr->val *= pow(1.0 - sr->a_data[2], sr->a_data[1] - sr->a_data[0]);
		}
	else yyargserr("Wrong number of arguments\nin call to  binomfreq(s, n, p).");
	return sr->val;
}

static double normdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = norm_dist(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  normdist(x, mean, SD).");
	return sr->val;
}

static double norminv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 3) {
		sr->val = distinv(norm_dist,sr->a_data[1], sr->a_data[2], sr->a_data[0], 2.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  norminv(p, mean, SD).");
	return sr->val;
}

static double normfreq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = norm_freq(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  normfreq(x, mean, SD).");
	return sr->val;
}

static double expdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = exp_dist(sr->a_data[0], sr->a_data[1], 0.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  expdist(x, l).");
	return sr->val;
}

static double expinv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2) {
		sr->val = exp_inv(sr->a_data[0], sr->a_data[1], 0.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  expinv(p, l).");
	return sr->val;
}

static double expfreq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = exp_freq(sr->a_data[0], sr->a_data[1], 0.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  expfreq(x, l).");
	return sr->val;
}

static double lognormdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = lognorm_dist(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  lognormdist(x, mean, SD).");
	return sr->val;
}

static double lognormfreq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = lognorm_freq(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  lognormfreq(x, mean, SD).");
	return sr->val;
}

static double lognorminv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 3) {
		sr->val = distinv(lognorm_dist,sr->a_data[1], sr->a_data[2], sr->a_data[0], 2.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  lognorminv(p, mean, SD).");
	return sr->val;
}

static double chidist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = chi_dist(sr->a_data[0], sr->a_data[1], 1.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  chidist(x, df).");
	return sr->val;
}

static double chiinv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2) {
		sr->val = distinv(chi_dist,sr->a_data[1], 1.0, sr->a_data[0], 2.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  chiinv(p, df).");
	return sr->val;
}

static double tdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = t_dist(sr->a_data[0], sr->a_data[1], 1.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  tdist(x, df).");
	return sr->val;
}

static double tinv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
        if(sr->a_data && sr->a_count == 2) {
		sr->val = distinv(t_dist,sr->a_data[1], 1.0, sr->a_data[0], 2.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  tinv(p, df).");
	return sr->val;
}

static double poisdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = pois_dist(sr->a_data[0], sr->a_data[1], 1.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  poisdist(x, mean).");
	return sr->val;
}

static double poisfreq(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0.0;
	if(sr->a_data && sr->a_count == 2){
		sr->val = exp(log(sr->a_data[1])*sr->a_data[0] - sr->a_data[1] - gammln(1.0 + sr->a_data[0]));
		}
	else yyargserr("Wrong number of arguments\nin call to  poisfreq(x, mean).");
	return sr->val;
}

static double fdist(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = f_dist(sr->a_data[0], sr->a_data[1], sr->a_data[2]);
		}
	else yyargserr("Wrong number of arguments\nin call to  fdist(x, df1, df2).");
	return sr->val;
}

static double finv(YYSTYPE *sr)
{
	if(!sr) return 0.0;
	sr->val = 0;
	if(sr->a_data && sr->a_count == 3){
		sr->val = distinv(f_dist,sr->a_data[1], sr->a_data[2], sr->a_data[0], 2.0);
		}
	else yyargserr("Wrong number of arguments\nin call to  finv(p, df1, df2).");
	return sr->val;
}

static double pearson(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count == sr2->a_count){
		sr1->val = sr2->val = d_pearson(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\npearson(range1; range2 [;\"dest\"]).");
	return sr1->val;
}

static double spearman(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count == sr2->a_count){
		sr1->val = sr2->val = d_spearman(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nspearman(range1; range2 [;\"dest\"]).");
	return sr1->val;
}

static double kendall(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count == sr2->a_count){
		sr1->val = sr2->val = d_kendall(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nkendall(range1; range2 [;\"dest\"]).");
	return sr1->val;
}

static double regression(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
	if(!(dest)) yyargserr("No destination range in call to function\nregression(range1; range2; \"dest\").");
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count == sr2->a_count){
		sr1->val = sr2->val = d_regression(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nregression(range1; range2; \"dest\").");
	return sr1->val;
}

static double covar(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count == sr2->a_count){
		sr1->val = sr2->val = d_covar(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\ncovar(range1; range2).");
	return sr1->val;
}

static double ttest(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr2->a_count > 1){
		sr1->val = sr2->val = d_ttest(sr1->a_data, sr2->a_data, sr1->a_count, sr2->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nttest(array1; array2[;\"dest\"]).");
	return sr1->val;
}

static double ttest2(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr2->a_count > 1){
		sr1->val = sr2->val = d_ttest2(sr1->a_data, sr2->a_data, sr1->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nttest2(range1; range2[;\"dest\"]).");
	return sr1->val;
}

static double utest(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr2->a_count > 1){
		sr1->val = sr2->val = d_utest(sr1->a_data, sr2->a_data, sr1->a_count, sr2->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nutest2(array1; array2[;\"dest\"]).");
	return sr1->val;
}

static double ftest(YYSTYPE *sr1, YYSTYPE *sr2, char *dest)
{
	if(!sr1 || !sr2) return 0.0;
	sr1->val = 0.0;
        if(sr1->a_data && sr1->a_count > 1 && sr2->a_data && sr1->a_count > 1){
		sr1->val = sr2->val = d_ftest(sr1->a_data, sr2->a_data, sr1->a_count, sr2->a_count, dest, curr_data);
		}
	else yyargserr("Bad arguments in call to function\nftest(range1; range2[;\"dest\"]).");
	return sr1->val;
}

static double fill(YYSTYPE *sr, char *dest)
{
	AccRange *ar;
	int i, r, c;

	if(!sr || !sr->a_data || !sr->a_count || !dest || !dest[0]) return 0.0;
	if(ar = new AccRange(dest)) {
		for(i=0, ar->GetFirst(&c, &r); ar->GetNext(&c, &r) && i < sr->a_count; i++) {
			curr_data->SetValue(r, c, sr->a_data[i]);
			}
		delete ar;
		}
	return sr->val = i;
}

static void datestr(YYSTYPE *dst, YYSTYPE *src, char *fmt)
{
	dst->text = PushString(value_date(src->val, fmt));
}

static double dateval(YYSTYPE *sr, YYSTYPE *dst, char *fmt)
{
	if(!sr || !sr->text) return 0.0;
	if(fmt && fmt[0] && date_value(sr->text, fmt, &dst->val)) return dst->val;
	if(date_value(sr->text, 0L, &dst->val)) return dst->val;
	else return dst->val = 0.0;
}

static double leapyear(double year)
{
	int y = (int)year;

	return (double)((y % 4 == 0 && y % 100 != 0) || y % 400 == 0);
}

static void today(YYSTYPE *dst, YYSTYPE *src)
{
	if(src) yyerror("parse error");
	if(!dst) return;
	dst->val = floor(now_today());
	dst->type = DATE1;
}

static void now(YYSTYPE *dst, YYSTYPE *src)
{
	if(src) yyerror("parse error");
	if(!dst) return;
	dst->val = now_today();			dst->val -= floor(dst->val);
	dst->type = TIME1;
}

static double year(double dv)
{
	int res;

	split_date(dv, &res, 0L, 0L, 0L, 0L, 0L, 0L, 0L);
	return (double)res;
}

static double month(double dv)
{
	int res;

	split_date(dv, 0L, &res, 0L, 0L, 0L, 0L, 0L, 0L);
	return (double)res;
}

static double dom(double dv)
{
	int res;

	split_date(dv, 0L, 0L, &res, 0L, 0L, 0L, 0L, 0L);
	return (double)res;
}

static double dow(double dv)
{
	int res;

	split_date(dv, 0L, 0L, 0L, &res, 0L, 0L, 0L, 0L);
	return (double)res;
}

static double doy(double dv)
{
	int res;

	split_date(dv, 0L, 0L, 0L, 0L, &res, 0L, 0L, 0L);
	return (double)res;
}

static double hours(double dv)
{
	int res;

	split_date(dv, 0L, 0L, 0L, 0L, 0L, &res, 0L, 0L);
	return (double)res;
}

static double minutes(double dv)
{
	int res;

	split_date(dv, 0L, 0L, 0L, 0L, 0L, 0L, &res, 0L);
	return (double)res;
}

static double seconds(double dv)
{
	double res;

	split_date(dv, 0L, 0L, 0L, 0L, 0L, 0L, 0L, &res);
	if(res < 0.0005) res = 0.0;
	return res;
}

static void fdate(YYSTYPE *dst, YYSTYPE *src)
{
	if(!dst || !src || src->type == ARR || src->type == STR) {
		yyerror("parse error");	
		return;
		}
	dst->type = DATE1;		dst->val = src->val;
}

static void fdatetime(YYSTYPE *dst, YYSTYPE *src)
{
	if(!dst || !src || src->type == ARR || src->type == STR) {
		yyerror("parse error");	
		return;
		}
	dst->type = DATETIME1;		dst->val = src->val;
}

static void ftime(YYSTYPE *dst, YYSTYPE *src)
{
	if(!dst || !src || src->type == ARR || src->type == STR) {
		yyerror("parse error");	
		return;
		}
	dst->type = TIME1;		dst->val = src->val;
}

static void asort(YYSTYPE *dst, YYSTYPE *src)
{
	if(!dst || !src) return;
	dst->type = ARR;
	switch(src->a_count) {
	case 0:
		dst->a_data = PushArray((double*)malloc(sizeof(double)));
		dst->a_count = 1;	dst->a_data[0] = dst->val = src->val;
		break;
	case 1:
		dst->a_data = PushArray((double*)malloc(sizeof(double)));
		dst->a_count = 1;	dst->a_data[0] = dst->val = src->a_data[0];
		break;
	default:
		dst->a_data = PushArray((double*)memdup(src->a_data, src->a_count * sizeof(double), 0));
		dst->a_count = src->a_count;
		SortArray(dst->a_count, dst->a_data);
		}
}

static void _crank(YYSTYPE *dst, YYSTYPE *src)
{
	double tmp;

	if(!dst || !src) return;
	dst->type = ARR;
	switch(src->a_count) {
	case 0:	case 1:
		dst->a_data = PushArray((double*)malloc(sizeof(double)));
		dst->a_count = 1;	dst->a_data[0] = dst->val = 1;
		break;
	default:
		dst->a_data = PushArray((double*)memdup(src->a_data, src->a_count * sizeof(double), 0));
		dst->a_count = src->a_count;
		crank(dst->a_count, dst->a_data, &tmp);
		}
}

static void ltrim(YYSTYPE *dst, YYSTYPE *src)
{
	if(!src || !dst || !src->text) return;
	dst->text = PushString(str_ltrim(strdup(src->text)));
	dst->type = STR;	dst->val = 0.0;
}

static void rtrim(YYSTYPE *dst, YYSTYPE *src)
{
	if(!src || !dst || !src->text) return;
	dst->text = PushString(str_rtrim(strdup(src->text)));
	dst->type = STR;	dst->val = 0.0;
}

static void trim(YYSTYPE *dst, YYSTYPE *src)
{
	if(!src || !dst || !src->text) return;
	dst->text = PushString(str_trim(strdup(src->text)));
	dst->type = STR;	dst->val = 0.0;
}

static double rank(YYSTYPE *sr) 
{
	if(sr->a_count < 2 || !sr->a_data) return 0.0;
	return d_rank(sr->a_count-1, sr->a_data+1, sr->a_data[0]);
}

static double classes(double start, double step, YYSTYPE *src, YYSTYPE *dest)
{
	return d_classes(curr_data, start, step, src->a_data, src->a_count, dest->text);
}

// Store strings in a list
static char **str_list = 0L;
static int n_str = 0;

static char *PushString(char *text)
{
	if(text && text[0]) {
		if(str_list = (char**)realloc(str_list, sizeof(char*)*(n_str+1)))
			str_list[n_str] = strdup(text);
		return str_list[n_str++];
		}
	return 0L;
}

//Store arrays in a list
static double **arr_list = 0L;
static int n_arr = 0;

static double *PushArray(double *arr)
{
	if(arr) {
		if(arr_list = (double**)realloc(arr_list, sizeof(double*)*(n_arr+1)))
			arr_list[n_arr] = arr;
		return arr_list[n_arr++];
		}
	return 0L;
}

static double *ReallocArray(double *arr, int size)
{
	int i;

	if(arr && size) {
		for(i = 0; i < n_arr; i++) if(arr_list[i] == arr) {
			arr_list[i] = (double*)realloc(arr, size);
			return arr_list[i];
			}
		arr = (double*)realloc(arr, size);
		return PushArray(arr);
		}
	return 0L;
}


//The symbol table: a chain of `struct symrec'
static symrec *sym_table, *sym_tab_first;

//Rearrange function table with previously used functions in front
void ArrangeFunctions()
{
	symrec *ptr, *ptr1, *ptr2, *next;

	for(ptr = sym_table, ptr1 = ptr2 = 0L; (ptr); ) {
		next = ptr->next;
		if(ptr->name) {
			ptr->next = ptr1;
			ptr1 = ptr;
			}
		else {
			ptr->next = ptr2;
			ptr2 = ptr;
			}
		ptr = next;
		}
	for(sym_table = 0L, ptr = ptr2; (ptr); ){
		next = ptr->next;
		ptr->next = sym_table;
		sym_table = ptr;
		ptr = next;
		}
	for(ptr = ptr1; (ptr); ){
		next = ptr->next;
		ptr->next = sym_table;
		sym_table = ptr;
		ptr = next;
		}
	sym_tab_first = sym_table;
	bRecent = false;
}

// Put arithmetic functions and predifened variables in table
#define INIT_SYM(TYP,NAM,FNC) {TYP,NAM,(double(*)(double))&FNC} 
void InitArithFuncs(DataObj *d)
{
	struct fdef {
		int f_type;
		char *name;
		double (*fnct)(double);
		};
	fdef fncts[] = {
	INIT_SYM(FUNC4, "classes", classes),
	INIT_SYM(AFNCT, "rank", rank),			INIT_SYM(YYFNC, "ltrim", ltrim),
	INIT_SYM(YYFNC, "rtrim", rtrim),		INIT_SYM(YYFNC, "trim", trim),
	INIT_SYM(YYFNC, "asort", asort),		INIT_SYM(YYFNC, "crank", _crank),
	INIT_SYM(SRFUNC, "datestr", datestr),		INIT_SYM(SFNCT, "dateval", dateval),
	INIT_SYM(BFNCT, "leapyear", leapyear),		INIT_SYM(YYFNC, "today", today),
	INIT_SYM(YYFNC, "now", now),			INIT_SYM(FNCT, "year", year),
	INIT_SYM(FNCT, "month", month),			INIT_SYM(FNCT, "dom", dom),
	INIT_SYM(FNCT, "dow", dow),			INIT_SYM(FNCT, "doy", doy),
	INIT_SYM(FNCT, "hours", hours),			INIT_SYM(FNCT, "minutes", minutes),
	INIT_SYM(FNCT, "seconds", seconds),		INIT_SYM(YYFNC, "date", fdate),
	INIT_SYM(FNCT, "datetime", fdatetime),		INIT_SYM(YYFNC, "time", ftime),
	INIT_SYM(FUNC1, "fill", fill),			INIT_SYM(FUNC2, "pearson", pearson),
	INIT_SYM(FUNC2, "spearman", spearman),		INIT_SYM(FUNC2, "kendall", kendall),		
	INIT_SYM(FUNC2, "correl", pearson),		INIT_SYM(FUNC2, "regression", regression),
	INIT_SYM(FUNC2, "covar", covar),
	INIT_SYM(FUNC3, "utest", utest),		INIT_SYM(FUNC2, "ttest2", ttest2),
	INIT_SYM(FUNC3, "ttest", ttest),		INIT_SYM(FUNC3, "ftest", ftest),
	INIT_SYM(AFNCT, "variance", variance),		INIT_SYM(AFNCT, "stdev", stdev),
	INIT_SYM(AFNCT, "sterr", sterr),		INIT_SYM(AFNCT, "min", min),
	INIT_SYM(AFNCT, "max", max),			INIT_SYM(AFNCT, "count", count),
	INIT_SYM(AFNCT, "sum", sum),			INIT_SYM(AFNCT, "mean", mean),
	INIT_SYM(AFNCT, "kurt", kurt),			INIT_SYM(AFNCT, "skew", skew),
	INIT_SYM(AFNCT, "median", quartile2),		INIT_SYM(AFNCT, "quartile1", quartile1),
	INIT_SYM(AFNCT, "quartile2",quartile2),		INIT_SYM(AFNCT, "quartile3", quartile3),
	INIT_SYM(AFNCT, "gmean", gmean),		INIT_SYM(AFNCT, "hmean", hmean),
	INIT_SYM(AFNCT, "tdist", tdist),		INIT_SYM(AFNCT, "tinv", tinv),
	INIT_SYM(AFNCT, "poisdist", poisdist),		INIT_SYM(AFNCT, "poisfreq", poisfreq),		
	INIT_SYM(AFNCT, "expdist", expdist),		INIT_SYM(AFNCT, "expfreq", expfreq),		
	INIT_SYM(AFNCT, "expinv", expinv),		INIT_SYM(AFNCT, "fdist", fdist),
	INIT_SYM(AFNCT, "finv", finv),			INIT_SYM(AFNCT, "gammp", _gammp),
	INIT_SYM(AFNCT, "gammq", _gammq),		INIT_SYM(AFNCT, "beta", beta),
	INIT_SYM(AFNCT, "betai", _betai),		INIT_SYM(AFNCT, "bincof", _bincof),
	INIT_SYM(AFNCT, "binomdist",binomdist),
	INIT_SYM(AFNCT, "binomfreq",binomfreq),
	INIT_SYM(AFNCT, "normdist", normdist),
	INIT_SYM(AFNCT, "norminv", norminv),		INIT_SYM(AFNCT, "normfreq", normfreq),
	INIT_SYM(AFNCT, "lognormdist", lognormdist),	INIT_SYM(AFNCT, "lognormfreq", lognormfreq),
	INIT_SYM(AFNCT, "lognorminv",lognorminv),	INIT_SYM(AFNCT, "chidist", chidist),
	INIT_SYM(AFNCT, "chiinv", chiinv),		INIT_SYM(SFNCT, "strlen", _strlen),
	INIT_SYM(SFNCT, "eval", eval),			INIT_SYM(FNCT, "erf", errf),
	INIT_SYM(FNCT, "erfc", errfc),			INIT_SYM(FNCT, "sign", sign),
	INIT_SYM(FNCT, "gammaln", gammln),		INIT_SYM(FNCT, "factorial", factorial),
	INIT_SYM(YYFNC, "rand", rand1),			INIT_SYM(FNCT, "srand", srand),
	INIT_SYM(FNCT, "floor", floor),			INIT_SYM(FNCT, "abs", fabs),
	INIT_SYM(FNCT, "asin", asin),			INIT_SYM(FNCT, "acos", acos),
	INIT_SYM(FNCT, "atan", atan),			INIT_SYM(FNCT, "sinh", sinh),
	INIT_SYM(FNCT, "cosh", cosh),			INIT_SYM(FNCT, "tanh", tanh),
	INIT_SYM(FNCT, "sin", sin),			INIT_SYM(FNCT, "cos", cos),
	INIT_SYM(FNCT, "tan", tan),			INIT_SYM(FNCT, "log10", log10),
	INIT_SYM(FNCT, "ln", log),			INIT_SYM(FNCT, "log", log),
	INIT_SYM(FNCT, "exp", exp),			INIT_SYM(FNCT, "sqrt", sqrt),
	INIT_SYM(0, 0L, nop)};
	int i;
	symrec *ptr, *next;

	if(d) curr_data = d;
	if(sym_table) {
		for (ptr = sym_table; ptr != (symrec *) 0;){
			if(ptr) {
				next = ptr->next;
				delete (ptr);
				}
			ptr = next;
			}
		sym_table = sym_tab_first = (symrec *) 0;
		}
	for (i = 0; fncts[i].name; i++) {
		ptr = putsym (HashValue((unsigned char*) fncts[i].name), Hash2((unsigned char*) fncts[i].name), fncts[i].f_type);
		ptr->fnctptr = (double (*)(...))fncts[i].fnct;
		}
	ptr = putsym(HashValue((unsigned char*)"zdiv"), Hash2((unsigned char*)"zdiv"), VAR);	ptr->SetValue(1.0);
	sym_tab_first = sym_table;
}
#undef INIT_SYM

static void init_table (void)
{
	str_list = 0L;		n_str = 0;
	arr_list = 0L;		n_arr = 0;
	push_syntax();
}

static void clear_table()
{
	int i;

	if(str_list) {
		for(i = 0; i < n_str; i++) if(str_list[i]) free(str_list[i]);
		free(str_list);		str_list = 0L;		n_str = 0;
		}
	if(arr_list) {
		for(i = 0; i < n_arr; i++) if(arr_list[i]) free(arr_list[i]);
		free(arr_list);		arr_list = 0L;		n_arr = 0;
		}
	pop_syntax();
}

static symrec *
putsym (unsigned int h_name, unsigned int h2_name, int sym_type)
{
	sym_table = new symrec(h_name, h2_name, sym_type, sym_table);
	return sym_table;
}

static symrec *
getsym (unsigned int h_name, unsigned int h2_name, char *sym_name)
{
	symrec *ptr;

	if(!h_name) return 0;
	for (ptr = sym_table; ptr != (symrec *) 0; ptr = (symrec *)ptr->next) {
		if (ptr->h_name == h_name && ptr->h2_name == h2_name){
			if(sym_name && !ptr->name) {
				ptr->SetName(sym_name);
				bRecent = true;
				}
			return ptr;
			}
		//predefined variables rarely end on a digit
		else if(ptr == sym_tab_first) {
			if(sym_name && isdigit(sym_name[strlen(sym_name)-1]) && strlen(sym_name) < 5) return 0;
			}
		}
	return 0;
}

static int
push(YYSTYPE *res, YYSTYPE *val)
{
	if(val->a_data) {
		if(!(res->a_data)) {
			if(!(val->a_data=ReallocArray(val->a_data, (val->a_count+2)*sizeof(double))))return 0;
			val->a_data[val->a_count++] = res->val;
			res->a_data = val->a_data;		res->a_count = val->a_count;
			val->a_data = 0L;			val->a_count = 0;
			val->val = res->val;			return 1;
			}
		else {
			if(!(res->a_data=ReallocArray(res->a_data, (val->a_count+res->a_count)*sizeof(double))))return 0;
			memcpy(&res->a_data[res->a_count], val->a_data, val->a_count*sizeof(double));
			res->a_count += val->a_count;
			val->a_data = 0L;			val->a_count = 0;
			return 1;
			}
		}
	if(!(res->a_data )){
		if(!(res->a_data =  PushArray((double*)malloc(2*sizeof(double)))))return 0;
		res->a_data[0] = res->val;			res->a_data[1] = val->val;
		res->a_count = 2;
		return 1;
		}
	else {
		if(!(res->a_data = ReallocArray(res->a_data, (res->a_count+2)*sizeof(double))))return 0; 
		res->a_data[res->a_count] = val->val;		res->a_count++;
		return 1;
		}
	return 0;
}

static int
range_array(YYSTYPE * res, char *range)
{
	AccRange *r;
	int row, col;
	anyResult ares;

	if(!range || !range[0] || !(r = new AccRange(range))) return 0;
	if(!r->GetFirst(&col, &row) || !(res->a_data =  PushArray((double*)malloc(r->CountItems() * sizeof(double))))) {
		delete(r);
		return 0;
		}
	parse_level++;
	for(res->a_count = 0; r->GetNext(&col, &row); ) {
		if(curr_data->GetResult(&ares, row, col, parse_level > MAX_PARSE)) {
			switch(ares.type) {
			case ET_VALUE:	case ET_TIME:	case ET_DATE:	case ET_DATETIME:	case ET_BOOL:
				res->a_data[res->a_count++] = ares.value;
				break;
				}
			}
		}
	parse_level--;
	delete(r);
	return 1;
}

static int
range_array2(YYSTYPE *res1, YYSTYPE *res2)
{
	AccRange *r1, *r2;
	int row1, col1, row2, col2;
	anyResult ares1, ares2;
	char *range1, *range2;

	range1 = res1->text;	range2 = res2->text;
	if(!range1 || !range1[0] || !range2 || !range2[0] || !(r1 = new AccRange(range1)) 
		|| !(r2 = new AccRange(range2))) return 0;
	if(!r1->GetFirst(&col1, &row1) || !(res1->a_data =  PushArray((double*)malloc(r1->CountItems() * sizeof(double))))) {
		delete(r1);	delete(r2);
		return 0;
		}
	if(!r2->GetFirst(&col2, &row2) || !(res2->a_data =  PushArray((double*)malloc(r2->CountItems() * sizeof(double))))) {
		delete(r1);	delete(r2);
		return 0;
		}
	parse_level++;
	for(res1->a_count = res2->a_count = 0; r1->GetNext(&col1, &row1) && r2->GetNext(&col2, &row2); ) {
		if(curr_data->GetResult(&ares1, row1, col1, parse_level > MAX_PARSE) 
			&& curr_data->GetResult(&ares2, row2, col2, parse_level > MAX_PARSE)
			&& (ares1.type==ET_VALUE || ares1.type==ET_TIME || ares1.type==ET_DATE || ares1.type==ET_DATETIME || ares1.type==ET_BOOL)
			&& (ares2.type==ET_VALUE || ares2.type==ET_TIME || ares2.type==ET_DATE || ares2.type==ET_DATETIME || ares2.type==ET_BOOL)){
			res1->a_data[res1->a_count++] = ares1.value;
			res2->a_data[res2->a_count++] = ares2.value;
			}
		}
	parse_level--;
	delete(r1);	delete(r2);
	return 1;
}

static YYSTYPE *proc_clause(YYSTYPE *res)
{
	int i, n, o_pos;
	char *o_cmd;
	double *n_data;

	if(!(syntax_level) || !syntax_level->cl1 || syntax_level->cl2 <= syntax_level->cl1) return res;
	if(!res->text) return res;
	if(!res->a_data && (res->a_data = PushArray((double*)malloc(sizeof(double))))) {
		res->a_data[0] = res->type == VAR && res->tptr ? res->tptr->GetValue() : res->val;
		res->a_count = 1;
		}
	else if(!res->a_data) return res;
	if(!(n_data = PushArray((double*)malloc(res->a_count * sizeof(double))))) return res;
	o_pos = buff_pos;	o_cmd = buffer;
	for(i = n = 0; i < res->a_count; i++) {
		buffer = res->text;	buff_pos = 0;
		if(!syntax_level) break;
		syntax_level->clval = res->a_data[i];
		yyparse();
		if(line_res.type == ET_VALUE && line_res.value != 0.0) n_data[n++] = res->a_data[i];
		}
	res->a_data = n_data;		res->a_count = n;
	res->text=0L;
	syntax_level->cl1 = syntax_level->cl2 = 0;
	buffer = o_cmd;	buff_pos = o_pos;
	return res;
}

static void exec_clause(YYSTYPE *res)
{
	int i, j;
	char *cmd;

	if((!res->a_data || res->a_count <2) && res->text && res->text[0]) range_array(res, res->text);
	if(!res->a_data) {
		if(res->a_data = PushArray((double*)malloc(2*sizeof(double)))) {
			res->a_data[0] = res->val;	res->a_count = 1;
			InfoBox("fixed data");
			}
		}
	if(!(syntax_level) || !syntax_level->cl1 || syntax_level->cl2 <= syntax_level->cl1) return;
	if(!(cmd = (char*)malloc(syntax_level->cl2 - syntax_level->cl1 +2)))return;
	while(buffer[syntax_level->cl1] <= ' ' && syntax_level->cl1 < syntax_level->cl2) syntax_level->cl1++;
	for(j = 0, i = syntax_level->cl1; i< syntax_level->cl2; i++) {
		cmd[j++] = buffer[i];
		}
	cmd[j++] = ';';		cmd[j++] = 0;
	res->text = PushString(cmd);
	free(cmd);
}

struct parse_info  {
	char *buffer;
	int buff_pos;
	DataObj *curr_data;
	symrec *sym_table;
	YYSTYPE yylval;
	struct parse_info *next;
	char **str_list;
	double **arr_list;
	char *last_err_desc;
	int n_str, n_arr, yychar, yynerrs;
};
static parse_info *parse_stack = 0L;

static void push_parser()
{
	parse_info *ptr;

	if(!sym_table) InitArithFuncs(0L);
	else if(!parse_level && bRecent) ArrangeFunctions();
	ptr = (parse_info *) malloc(sizeof(parse_info));
	ptr->buffer = buffer;			ptr->buff_pos = buff_pos;
	ptr->curr_data = curr_data;		ptr->last_err_desc = last_err_desc;
	ptr->sym_table = sym_table;		sym_table = sym_tab_first;
	memcpy(&ptr->yylval, &yylval, sizeof(YYSTYPE));
	ptr->next = parse_stack;
	ptr->str_list = str_list;		str_list = 0L;
	ptr->n_str = n_str;			n_str = 0;
	ptr->arr_list = arr_list;		arr_list = 0L;
	ptr->n_arr = n_arr;			n_arr = 0;
	ptr->yychar = yychar;			ptr->yynerrs = yynerrs;
	parse_stack = ptr;			last_err_desc = 0L;
	parse_level++;				//reenter ?
	push_syntax();				syntax_level->last_tok = 0;
}

static void pop_parser()
{
	parse_info *ptr;
	symrec *n;

	if(ptr = parse_stack) {
		while(sym_table  && sym_table != sym_tab_first) {
			n = sym_table->next;
			delete(sym_table);
			sym_table = n;
			}
		if(sym_table) sym_table = ptr->sym_table;
		parse_stack = ptr->next;
		buffer = ptr->buffer;		buff_pos = ptr->buff_pos;
		curr_data = ptr->curr_data;	last_err_desc = ptr->last_err_desc;
		memcpy(&yylval, &ptr->yylval, sizeof(YYSTYPE));
		str_list = ptr->str_list;	n_str = ptr->n_str;
		arr_list = ptr->arr_list;	n_arr = ptr->n_arr;
		yychar = ptr->yychar;		yynerrs = ptr->yynerrs;
		free(ptr);
		parse_level--;
		}
	pop_syntax();
}

static int is_ttoken(unsigned int h_nam, unsigned int h2_nam)
{
	switch(h_nam) {
	case 69:
		if(h2_nam == 101) return E;
		break;
	case 393:
		if(h2_nam == 47081) return PI;
		break;
	case 28381:
		if((h2_nam & 0x7fffffff) == 0x7c2706ed) {
			if(syntax_level) syntax_level->cl1 = buff_pos;
			return CLAUSE;
			}
		break;
	case 20:
		if(h2_nam == 5220) return CLVAL;
		break;
	case 362:
		if(h2_nam == 42878) return IF;
		break;
	case 1457:
		if(h2_nam == 18357885) return DIM;
		break;
	case 6033:
		if((h2_nam & 0x7fffffff) == 0x6371377d) return ELSE;
		break;
	case 7097:
		if((h2_nam & 0x7fffffff) == 0x550a2d65) return BTRUE;
		break;
	case 23697:
		if((h2_nam & 0x7fffffff) == 0x155f977d) return BFALSE;
		break;
		}
	return 0;
}

static symrec *curr_sym;
static int yylex (void)
{
	int i, c, tok;
	unsigned int h_nam, h2_nam;
	char tmp_txt[80];
	symrec *s;

	while((c = buffer[buff_pos++]) == ' ' || c == '\t');	//get first nonwhite char
	if(!c) return 0;
	//test for block statement
	if(c == '{') {
		for(i= 0; i < 79 && ((tok = buffer[buff_pos]) && (tok != '}')); buff_pos++) {
			tmp_txt[i++] = (char)tok;
			}
		if(buffer[buff_pos] == '}')buff_pos++;
		tmp_txt[i] = 0;
		yylval.text = PushString(tmp_txt);
		return yylval.type = BLOCK;
		}
	//test for '..' operator
	if(c == '.' && buffer[buff_pos] == '.') {
		buff_pos++;
		return yylval.type = SER;
		}
	//test for number
	if(c == '.' || isdigit(c)) {
		for(buff_pos--, i = 0; i < 79 && ((c = buffer[buff_pos]) == '.' || isdigit(c)); buff_pos++) {
			tmp_txt[i++] = (char)c;
			if(i && buffer[buff_pos+1] == 'e' && (buffer[buff_pos+2] == '-' || buffer[buff_pos+2] == '+')){
				tmp_txt[i++] = buffer[++buff_pos];
				tmp_txt[i++] = buffer[++buff_pos];
				}
			if(i && buffer[buff_pos+1] == '.' && buffer[buff_pos+2]  == '.') {	//operator '..'
				buff_pos++;
				break;
				}
			}
		tmp_txt[i] = 0;
		sscanf(tmp_txt, "%lf", &yylval.val);
		return yylval.type = NUM;
		}
	//test for name or stringtoken
	if(isalpha(c) || c=='$') {
 		for(buff_pos--, i = 0; i < 79 && ((c = buffer[buff_pos]) && (isalnum(c) || c == '$')); buff_pos++) {
			tmp_txt[i++] = (char)c; 
			}
		tmp_txt[i] = 0;
		h_nam = HashValue((unsigned char*)tmp_txt);
		h2_nam = Hash2((unsigned char*)tmp_txt);
		if(h_nam == 1550 && h2_nam == 18852086) {	//'inf' = huge value
			yylval.val = HUGE_VAL;
			return yylval.type = NUM;
			}
		if(tok = is_ttoken(h_nam, h2_nam)) return tok;
		if(!(s = getsym(h_nam, h2_nam, tmp_txt))){
			s = putsym(h_nam, h2_nam, VAR);
			s->SetName(tmp_txt);
			}
		
		curr_sym = yylval.tptr = s;	return s->type;
		}
	//test for string
	if(c == '"' || c == '\'') {
		for(i= 0; i < 79 && ((tok = buffer[buff_pos]) && (tok != c)); buff_pos++) {
			tmp_txt[i++] = (char)tok;
			}
		if(buffer[buff_pos] == c)buff_pos++;
		tmp_txt[i] = 0;
		yylval.text = PushString(tmp_txt);
		return yylval.type = STR;
		}
	tok = 0;
	switch(c) {
	case '=':
		if(buffer[buff_pos] == '=') tok = EQ;
		break;
	case '!':
		if(buffer[buff_pos] == '=') tok = NE;
		break;
	case '>':
		if(buffer[buff_pos] == '=') tok = GE;
		else return GT;
		break;
	case '<':
		if(buffer[buff_pos] == '=') tok = LE;
		else if(buffer[buff_pos] == '>') tok = NE;
		else return LT;
		break;
	case '&':
		if(buffer[buff_pos] == '&') tok = AND;
		break;
	case '|':
		if(buffer[buff_pos] == '|') tok = OR;
		break;
	case ')':
		if(syntax_level) {
			if(syntax_level->cl1 && syntax_level->next) {
				syntax_level->next->cl1 = syntax_level->cl1;
				syntax_level->next->cl2 = buff_pos-1;
				}
			}
		pop_syntax();
		break;
	case '(':
		push_syntax();
	case '?':
		if(syntax_level) syntax_level->last_tok = c;
		break;
	case ':':
		if(syntax_level) {
			if(syntax_level->last_tok == '(') return COLR;
			else if(syntax_level->last_tok == '?') return COLC;
			}
		break;
	case ';':
		if(syntax_level) {
			if(syntax_level->last_tok == '(') return PSEP;
			}
		break;
	case '+':
		if(buffer[buff_pos] == '+') tok = INC;
		break;
	case '-':
		if(buffer[buff_pos] == '-') tok = DEC;
		break;
		}
	if(tok) {
		buff_pos++;		return tok;
		}
	//Any other character is a token by itself
	return c;
}

static unsigned int hn_x = HashValue((unsigned char *)"x");
static unsigned int hn_y = HashValue((unsigned char *)"y");
static unsigned int hn_z = HashValue((unsigned char *)"z");
static unsigned int h2_x = Hash2((unsigned char *)"x");
static unsigned int h2_y = Hash2((unsigned char *)"y");
static unsigned int h2_z = Hash2((unsigned char *)"z");

bool do_xyfunc(DataObj *d, double x1, double x2, double step, char *expr, lfPOINT **pts, long *npts, char *param)
{
	double x, y;
	symrec *sx, *sy;
	lfPOINT *new_points;
	long npoints = 0;
	int length, res_mode = 0;

	if(x1 < x2) step = fabs(step);
	else step = -fabs(step);
	if(!(new_points = (lfPOINT*)calloc((iround(fabs(x2-x1)/fabs(step))+2), sizeof(lfPOINT))))
		return false;
	if(d) curr_data = d;
	push_parser();
	init_table();
	if(param) {
		length = strlen(param);
		if(!(buffer = (char*)malloc(length+2))){
			pop_parser();
			return false;
			}
		strcpy(buffer, param);	buffer[length++] = ';';
		buffer[length] = 0;	buff_pos = 0;
		do {
			yyparse();
			}while(buff_pos < length);
		free(buffer);		buffer = 0L;
		}		
	length = strlen(expr);
	buffer = expr;		sx = putsym(hn_x, h2_x, VAR);
	for(x = x1; step > 0.0 ? x <= x2 : x >= x2; x += step) {
		if(sx){
			sx->SetValue(x);	buff_pos = 0;
			do {
				yyparse();
				}while(buff_pos < length);
			switch (res_mode) {
			case 1:
				y = sy->GetValue();	break;
			case 2:
				y = line_res.value;	break;
			default:
				if(sy = getsym(hn_y, h2_y)) {
					y = sy->GetValue();	res_mode = 1;
					}
				else {
					y = line_res.value;	res_mode = 2;
					}
				break;
				}
			new_points[npoints].fx = (getsym(hn_x, h2_x))->GetValue();
			new_points[npoints++].fy = y;
			}
		}
	*pts = new_points;	*npts = npoints;
	clear_table();
	pop_parser();
	if(curr_data) {
		curr_data->Command(CMD_CLEAR_ERROR, 0L, 0L);
		curr_data->Command(CMD_REDRAW, 0L, 0L);
		}
	return true;
}

bool do_func3D(DataObj *d, double x1, double x2, double xstep, double z1, double z2, double zstep, 
	char *expr, char *param)
{
	int length, nr, nc, r, c, res_mode=0;
	symrec *sx, *sz, *sy;
	double x, y, z;

	if(!d || x2 <= x1 || z2 <= z1 || xstep <= 0.0 || zstep <= 0.0) return false;
	push_parser();
	init_table();
	if(param) {
		length = strlen(param);
		if(!(buffer = (char*)malloc(length+2))){
			pop_parser();
			return false;
			}
		strcpy(buffer, param);	buffer[length++] = ';';
		buffer[length] = 0;	buff_pos = 0;
		do {
			yyparse();
			}while(buff_pos < length);
		free(buffer);		buffer = 0L;
		}		
	length = strlen(expr);		buffer = expr;
	sx = putsym(hn_x, h2_x, VAR);	sz = putsym(hn_z, h2_z, VAR);
	nr = iround((z2-z1)/zstep)+1;	nc = iround((x2-x1)/xstep)+1;
	d->Init(nr, nc);
	for(r = 0, x = x1; r < nr; r++, x += xstep) {
		for(c = 0, z = z1; c < nc; c++, z+= zstep) {
			sx->SetValue(x);	sz->SetValue(z);	buff_pos = 0;
			do {
				yyparse();
				}while(buff_pos < length);
			switch (res_mode) {
			case 1:
				y = sy->GetValue();	break;
			case 2:
				y = line_res.value;	break;
			default:
				if(sy = getsym(hn_y, h2_y)) {
					y = sy->GetValue();	res_mode = 1;
					}
				else {
					y = line_res.value;	res_mode = 2;
					}
				break;
				}
			d->SetValue(r, c, y);
			}
		} 
	clear_table();
	pop_parser();
	return true;
}

anyResult *do_formula(DataObj *d, char *expr)
{
	int length;
	static anyResult ret, *pret = 0L;

	if(d) curr_data = d;
	ret.type = ET_ERROR;		ret.text = 0L;
	if(!expr || !expr[0]) {
		if(!sym_table) InitArithFuncs(0L);
		return &ret;
		}
	push_parser();		//make code reentrant
	init_table();		length = strlen(expr);
	if(!(buffer = (char*)malloc(length+2))){
		pop_parser();
		return &ret;
		}
	strcpy(buffer, expr);	if(buffer[length-1] != ';') buffer[length++] = ';';
	buffer[length] = 0;	buff_pos = 0;
	do {
		yyparse();
		}while(buff_pos < length);
	ret.type = ET_ERROR;		ret.text = 0L;
	if(curr_data && last_error) {
		if(!(strcmp(last_error, "parse error"))) curr_data->Command(CMD_ERROR, 0L, 0L);
		if(last_err_desc) pret = &line_res;
		else pret = &ret;
		}
	else pret = &line_res;
	last_error = last_err_desc = 0L;
	free(buffer);		buffer = 0L;
	clear_table();
	pop_parser();
	return pret;
}

bool MoveFormula(DataObj *d, char *of, char *nf, int dx, int dy, int r0, int c0)
{
	int length, tok, pos, i;
	char *res, desc1[2], desc2[2];

	if(d) curr_data = d;
	if(!curr_data || !of || !nf) return false;
	push_parser();		//make code reentrant
	init_table();		length = strlen(of);
	if(!(buffer = (char*)malloc(length+2))){
		pop_parser();
		return false;
		}
	strcpy(buffer, of);	buffer[length++] = ';';
	buffer[length] = 0;	buff_pos = pos = 0;
	res = (char *)calloc(length*2+10, sizeof(char));
	do {
		tok = yylex ();
		if(tok && tok < 256) {
			if(res[pos-1] == ' ') pos--;
			res[pos++] = (char)tok;
			}
		else switch(tok) {
			case NUM:
				pos += sprintf(res+pos, "%g", yylval.val);
				break;
			case FNCT:	case FUNC1:	case FUNC2:	case FUNC3:	case AFNCT:
			case SFNCT:	case SRFUNC:	case BFNCT:	case YYFNC:	case FUNC4:
				pos += sprintf(res+pos, "%s", curr_sym->name);
				break;
			case COLR:			case COLC:
				pos += sprintf(res+pos, ":");
				break;
			case PSEP:
				pos += sprintf(res+pos, ";");
				break;
			case CLVAL:
				pos += sprintf(res+pos, "$$");
				break;
			case CLAUSE:
				pos += sprintf(res+pos, " where ");
				break;
			case VAR:
				curr_sym->InitSS();
				if(curr_sym->col >= 0 && curr_sym->row >= 0) {
					desc1[0] = desc1[1] = desc2[0] = desc2[1] = 0;
					for(i=strlen(curr_sym->name)-1; i>0 && isdigit(curr_sym->name[i]); i--);
					if(curr_sym->name[0] == '$') desc1[0] = '$';
					if(curr_sym->name[i] == '$') desc2[0] = '$';
					pos += sprintf(res+pos, "%s%s%s%d", desc1, 
						Int2ColLabel(desc1[0] || curr_sym->col < c0 ? curr_sym->col : curr_sym->col+dx >=0 ?
						curr_sym->col+dx > c0 ? curr_sym->col+dx : c0 : 0, false),
						desc2, desc2[0] || curr_sym->row < r0 ? curr_sym->row+1 : curr_sym->row + dy >= 0 ? 
						curr_sym->row+dy > r0 ? curr_sym->row+1+dy : r0 : 1);
					}
				else pos += sprintf(res+pos, "%s ", curr_sym->name);
				break;
			case STR:
				pos += sprintf(res+pos, "\"%s\"", yylval.text && yylval.text[0] ? yylval.text : "");
				break;
			case SER:
				pos += sprintf(res+pos, "..");
				break;
			case INC:
				pos += sprintf(res+pos, "++");
				break;
			case DEC:
				pos += sprintf(res+pos, "--");
				break;
			case PI:
				pos += sprintf(res+pos, "pi");
				break;
			case E:
				pos += sprintf(res+pos, "e");
				break;
			case BTRUE:
				pos += sprintf(res+pos, "true");
				break;
			case BFALSE:
				pos += sprintf(res+pos, "false");
				break;
			case AND:
				pos += sprintf(res+pos, " && ");
				break;
			case OR:
				pos += sprintf(res+pos, " || ");
				break;
			case EQ:
				pos += sprintf(res+pos, " == ");
				break;
			case NE:
				pos += sprintf(res+pos, " != ");
				break;
			case GT:
				pos += sprintf(res+pos, ">");
				break;
			case GE:
				pos += sprintf(res+pos, ">=");
				break;
			case LT:
				pos += sprintf(res+pos, "<");
				break;
			case LE:
				pos += sprintf(res+pos, "<=");
				break;
			case IF: 
				pos += sprintf(res+pos, "if");
				break;
			case ELSE: 
				pos += sprintf(res+pos, "else");
				break;
			case BLOCK:
				pos += sprintf(res+pos, "{%s}", yylval.text && yylval.text[0] ? yylval.text : "");
				break;
			}
		}while(buff_pos < length);
	while((res[pos-1] == ';' || res[pos-1] == ' ') && pos > 0) { res[pos-1] = 0; pos--;} 
	strcpy(nf, res);	free(res);
	free(buffer);		buffer = 0L;
	clear_table();
	pop_parser();
	return true;
}

static char *txt_formula;	//function to fit
static double **parval;		//pointers to parameter values
static void fcurve(double x, double z, double **a, double *y, double dyda[], int ma)
{
	int i, length;
	double tmp, y1, y2;
	symrec *symx, *symz, *sy=0L;

	if(!(symx = getsym(hn_x, h2_x))) symx = putsym(hn_x, h2_x, VAR);
	if(!(symz = getsym(hn_z, h2_z))) symz = putsym(hn_z, h2_z, VAR);
	//swap parameters to requested set
	if(a != parval) for(i = 0; i < ma; i++) {
		tmp = *parval[i];	*parval[i]  = *a[i];	*a[i] = tmp;
		}
	//calc result
	symx->SetValue(x);	symz->SetValue(z);	
	buffer = txt_formula;
	buff_pos = 0;		length = strlen(txt_formula);
	do {	yyparse();	}while(buff_pos < length);
	if(sy = getsym(hn_y, h2_y)) *y = sy->GetValue();
	else *y = line_res.value;
	if(*y == HUGE_VAL || *y == -HUGE_VAL) {
		for(i = 0, *y = 0.0; i < ma; dyda[i++] = 0.0);
		return;
		}
	//partial derivatives for each parameter by numerical differentiation
	for(i = 0; i < ma; i++) {
		if(*parval[i] != 0.0) {
			tmp = *parval[i];
			*parval[i] = tmp*.995;
			buff_pos = 0;
			do {	yyparse();	}while(buff_pos < length);
			y1 = sy ? sy->GetValue() : line_res.value;
			*parval[i] = tmp*1.005;
			buff_pos = 0;
			do {	yyparse();	}while(buff_pos < length);
			y2 = sy ? sy->GetValue() : line_res.value;
			*parval[i] = tmp;
			dyda[i] = (y2-y1)*100.0/tmp;
			}
		else dyda[i] = 0.0;
		}
	//swap parameters back to original
	if(a != parval) for(i = 0; i < ma; i++) {
		tmp = *parval[i];	*parval[i]  = *a[i];	*a[i] = tmp;
		}
}

int do_fitfunc(DataObj *d, char *rx, char *ry, char *rz, char **par, char *expr, double conv, int maxiter, double *chi_2)
{
	int length, i, j, k, l, ndata, nparam, r1, r2, r3, c1, c2, c3, *lista, itst, itst1;
	symrec *tab1, *tab2, *csr, **parsym;
	AccRange *arx, *ary, *arz;
	double *x, *y, *z, currx, curry, currz, alamda, chisq, ochisq;
	double **covar, **alpha;
	char tmp_txt[500];

	if(d) curr_data = d;
	if(chi_2) *chi_2 = 0.0;
	txt_formula = expr;
	if(!curr_data || !par || !expr || !rx || !ry) return 0;
	//process ranges and create arrays
	arx = ary = arz = 0L;	x = y = z = 0L;	parval = 0L;	parsym = 0L;
	if(!(arx = new AccRange(rx)))return 0;
	i = arx->CountItems()+1;
	if(!(ary = new AccRange(ry))){
		delete arx;	return 0;
		}
	if(rz && !(arz = new AccRange(rz))){
		delete ary;	delete arx;	return 0;
		}
	if(!(x = (double*)malloc(i * sizeof(double)))){
		if(arz) delete arz;
		delete ary;	delete arx;	return 0;
		}
	if(!(y = (double*)malloc(i * sizeof(double)))){
		if(arz) delete arz;
		free(x);	delete arx;	delete ary;	return 0;
		}
	if(rz && !(z = (double*)malloc(i * sizeof(double)))){
		if(arz) delete arz;
		free(y);	free(x);	delete arx;	delete ary;	return 0;
		}
	arx->GetFirst(&c1, &r1);	ary->GetFirst(&c2, &r2);
	if(rz) arz->GetFirst(&c3, &r3);
	for(ndata = j = 0; j < i; j++) {
		if(rz) {
			if(arx->GetNext(&c1, &r1) && ary->GetNext(&c2, & r2) && arz->GetNext(&c3, &r3) &&
				curr_data->GetValue(r1, c1, &currx) && curr_data->GetValue(r2, c2, &curry) &&
				curr_data->GetValue(r3, c3, &currz)) {
				x[ndata] = currx;	y[ndata] = curry;	z[ndata] = currz;	ndata++;
				}
			}
		else {
			if(arx->GetNext(&c1, &r1) && ary->GetNext(&c2, & r2) &&
				curr_data->GetValue(r1, c1, &currx) && curr_data->GetValue(r2, c2, &curry)) {
				x[ndata] = currx;	y[ndata] = curry;	ndata++;
				}
			}
		}
	//common initialization for parser tasks
	push_parser();		//make code reentrant
	init_table();		length = strlen(*par);
	//process parameters
	if(!(buffer = (char*)malloc(length+2))){
		clear_table();	pop_parser();
		if(arz) delete arz;
		free(y);	free(x);	delete arx;	delete ary;
		return 0;
		}
	strcpy(buffer, *par);	buffer[length++] = ';';
	buffer[length] = 0;	buff_pos = 0;
	tab1 = sym_table;
	do {
		yyparse();
		}while(buff_pos < length);
	tab2 = sym_table;	free(buffer);	buffer =0L;
	for(nparam = 0, csr=tab2; csr != tab1; nparam++, csr = csr->next);
	parsym = (symrec**)malloc((nparam+1)*sizeof(symrec*));
	parval = (double**)malloc((nparam+1)*sizeof(double*));
	for(i = 0, csr=tab2; csr != tab1 && i < nparam; i++, csr = csr->next){
		parsym[i] = csr;	parval[i] = &csr->var;
		}
	//do iteratations to optimize fit
	lista = (int*)malloc(sizeof(int)*nparam);
	for(i = 0; i< nparam; i++) lista[i] = i;
	covar = dmatrix(1, nparam, 1, nparam);
	alpha = dmatrix(1, nparam, 1, nparam);
	alamda = -1.0;		itst = 0;
	mrqmin(x, y, z, ndata, parval, nparam, lista, nparam, covar, alpha, &chisq, fcurve, &alamda);
	if(!Check_MRQerror()) {
		for(itst = itst1 = 0, ochisq = chisq; itst < maxiter && chisq > conv && ochisq >= chisq && itst1 < 9; itst++) {
			ochisq = chisq;
			mrqmin(x, y, z, ndata, parval, nparam, lista, nparam, covar, alpha, &chisq, fcurve, &alamda);
			if(ochisq == chisq) itst1++;
			else itst1 = 0;
			}
		alamda = 0.0;
		mrqmin(x, y, z, ndata, parval, nparam, lista, nparam, covar, alpha, &chisq, fcurve, &alamda);
		Check_MRQerror();
		}
	for(i = nparam-1, j = k = l = 0; i >= 0; l = 0, i--) {
		if(k > 20) {
			if(tmp_txt[j-1] == ' ') j--;
			if(tmp_txt[j-1] == ';') j--;
			l = sprintf(tmp_txt+j, "\n");
			j += l;		k = 0;
			}
		l += sprintf(tmp_txt+j, "%s%s=%g;", j && k ? " " : "", parsym[i]->name, parsym[i]->GetValue());
		j += l;			k += l;
		}
	free(*par);	*par = strdup(tmp_txt);
	if(chi_2) *chi_2 = chisq;
	//write back spreadsheet data if necessary
	buffer = *par;	length = strlen(buffer);
	do {
		yyparse();
		}while(buff_pos < length);
	buffer = 0L;
	free_dmatrix(alpha, 1, nparam, 1, nparam);
	free_dmatrix(covar, 1, nparam, 1, nparam);
	if(arz) delete arz;		if(z) free(z);
	free(y);	free(x);	delete arx;	delete ary;
	if(parval) free(parval);	if(parsym) free(parsym);
	clear_table();
	pop_parser();
	if(curr_data){
		curr_data->Command(CMD_CLEAR_ERROR, 0L, 0L);
		curr_data->Command(CMD_REDRAW, 0L, 0L);
		}
	return itst < maxiter ? itst+1 : maxiter;
}









